http://ppdbooks.pok.ibm.com:80/cgi-bin/bookmgr/bookmgr.cmd/books/PEOP1230/2.1.1.1 
 
 
 [Library]    [Contents]   [Revisions]    [Prev Topic]   [Next Topic]

 [Search]    [Search Results]   [Prev Topic Match]   [Next Topic Match]

 [Notes]    [List Notes]   [Print]   [Help]

----------------------------------------------------------------------------

2.1.1.1 Creating a Static Executable

Note: We discourage you from creating statically bound executables with POE.
If service is ever applied that affects any of the Parallel Environment
libraries, you will need to recompile your application to create a new
executable that will work with the new libraries. This could lead to a lot
of work and may expose you to potential problems, which would be avoided if
dynamic libraries are used.

In general, to create a static executable, do the following:

  1.
     | Create an object file of your program using cc, xlf, or xlC. For your

     | threaded program, use cc_r or xlC_r. Include the path
     /usr/lpp/ppe.poe/include to the message passing include files in your
     compilation statement. For example:

              cc -c myprog.c -I/usr/lpp/ppe.poe/include

  2. Using ld, create the executable.

The following table shows how you create a C, C++, or Fortran static
executable for IP or US.

Note: When you see ld, l represents a lower case L. When you see -bI, I
represents an upper case i.

    _________ _______________________________ ______________________________
   | To:     | For IP, Enter:                | For US (SP only), Enter:     |
   |_________|_______________________________|______________________________|
   | Create  | ld -o myprog myprog.o         | ld -o myprog myprog.o        |
   | a C or  | /lib/crt0.o                   | /lib/crt0.o                  |
   | C++     | -binitfini:poe_remote_main    | -binitfini:poe_remote_main   |
   | static  | -bnso -lmpci -lmpi -lvtd -lc  | -bnso                        |
   | executab|e-lppe -bI:/lib/syscalls.exp   | -bI:/usr/lpp/ssp/css/libus/fs|ext.exp
   |         | -L/usr/lpp/ppe.poe/lib        | -lmpci -lmpi -lvtd -lc -lppe |
   |         | -L/usr/lpp/ppe.poe/lib/ip     | -bI:/lib/syscalls.exp        |
   |         |                               | -L/usr/lpp/ppe.poe/lib       |
   |         |                               | -L/usr/lpp/ppe.poe/lib/us    |
   |_________|_______________________________|______________________________|
   | Create  | ld -o myprog myprog.o         | ld -o myprog myprog.o        |
   | a       | /lib/crt0.o                   | /lib/crt0.o                  |
   | Fortran | -binitfini:poe_remote_main    | -binitfini:poe_remote_main   |
   | static  | -bnso -lmpci -lmpi -lvtd      | -bnso                        |
   | executab|e-lxlf90 -lxlf -lc -lppe       | -bI:/usr/lpp/ssp/css/libus/fs|ext.exp
   |         | -bI:/lib/syscalls.exp         | -lmpci -lmpi -lvtd -lxlf90   |
   |         | -L/usr/lpp/ppe.poe/lib        | -lxlf -lc -lppe              |
   |         | -L/usr/lpp/ppe.poe/lib/ip     | -bI:/lib/syscalls.exp        |
   |         |                               | -L/usr/lpp/ppe.poe/lib       |
   |         |                               | -L/usr/lpp/ppe.poe/lib/us    |
   |_________|_______________________________|______________________________|
 | | Create  | ld -o myprog myprog.o         | ld -o myprog myprog.o        |
 | | a C or  | /lib/crt0_r.o                 | /lib/crt0_r.o                |
 | | C++     | -binitfini:poe_remote_main    | -binitfini:poe_remote_main   |
 | | static  | -bnso -lmpi_r -lvtd_r -lc_r   | -bnso                        |
 | | executab|e-lppe_r -lpthreads -lmpci_r   | -bI:/usr/lpp/ssp/css/libus/fs|ext.exp
 | | which   | -lc /usr/lib/libc.a           | -lmpi_r -lvtd_r -lc_r        |
 | | uses    | -bI:/lib/threads.exp          | -lppe_r -lpthreads -lmpci_r  |
 | | threaded| -bI:/lib/syscalls.exp         | -lc /usr/lib/libc.a          |
 | | MPI     | -L/usr/lib/threads            | -bI:/lib/threads.exp         |
 | |         | -L/usr/lpp/ppe.poe/lib        | -bI:/lib/syscalls.exp        |
 | |         | -L/usr/lpp/ppe.poe/lib/ip     | -L/usr/lib/threads           |
 | |         |                               | -L/usr/lpp/ppe.poe/lib       |
 | |         |                               | -L/usr/lpp/ppe.poe/lib/us    |
   |_________|_______________________________|______________________________|
 | | Create  | ld -o myprog myprog.o         | ld -o myprog myprog.o        |
 | | a       | /lib/crt0_r.o                 | /lib/crt0_r.o                |
 | | Fortran | -binitfini:poe_remote_main    | -binitfini:poe_remote_main   |
 | | static  | -bnso -lmpci_r -lmpi_r        | -bnso                        |
 | | executab|e-lvtd_r -lxlf90_r -lc_r       | -bI:/usr/lpp/ssp/css/libus/fs|ext.exp
 | | which   | -lppe_r -lc -lpthreads        | -lmpci_r -lmpi_r -lvtd_r     |
 | | uses    | /usr/lib/libc.a               | -lxlf90_r -lc_r -lppe_r -lc  |
 | | threaded| -bI:/lib/syscalls.exp         | -lpthreads /usr/lib/libc.a   |
 | | MPI     | -bI:/lib/threads.exp          | -bI:/lib/syscalls.exp        |
 | |         | -L/usr/lib/threads            | -bI:/lib/threads.exp         |
 | |         | -L/usr/lpp/ppe.poe/lib        | -L/usr/lpp/ppe.poe/lib       |
 | |         | -L/usr/lpp/ppe.poe/lib/ip     | -L/usr/lpp/ppe.poe/lib/us    |
   |_________|_______________________________|______________________________|

Notes:

| 1. Users of PE 2.1 and 2.2 who have made references to any crt0 in
| /usr/lpp/ppe.poe/lib (for example, users who create statically bound
| executables) and who wish to recompile using PE 2.3 should do the
| following:

  1.
     | References to any crt0 in /usr/lpp/ppe.poe/lib should be changed
     | to the desired crt0 in /lib or /usr/lpp/xlC/lib.

  2.
     | The -binitfini:poe_remote_main binder option should be added to
     | the compile or ld statement.

| 2. POE compile scripts utilize the -binitfini binder option. As a
| result, POE programs have a priority default of zero. If other user
| applications are using the initfini binder option, they should only
| specify a priority in the range of 1 to 2,147,483,647.

     3. If you try to create a US static executable on the SP control
workstation, and the ld command fails because it cannot find the mpci
library file, it is possible that a link needs to be set by your system
administrator. Refer to IBM Parallel Environment for AIX: Installation for
instructions on installing PE on the SP control workstation.

     4. On a cluster, you can create an IP static executable only. The US
libraries are only shipped with an SP system.

     5. To create a Fortran static executable, you should have Fortran
Release 3.2.2 or later.

     6. When creating a Fortran static executable, include the xlf90 and xlf
libraries in the ld command after the -lvtd statement.

| 7. To use threads and Fortran, you should have Fortran Release 4.1.0.1.

| 8. To create a static executable of a program which uses LAPI
| subroutines, see "Understanding and Using the Communications Low-Level
| Application Programming Interface (LAPI)," in IBM Parallel System
| Support Programs for AIX: Administration Guide.
----------------------------------------------------------------------------

 [Prev Topic]    [Next Topic]   Copyright IBM Corp. 1996, 1997

----------------------------------------------------------------------------

IBM BookManager BookServer Copyright 1989, 1996 IBM Corporation. All rights
reserved.
