
/***************************************************************************
  20 June 1996 1:00pm
  
  Copyright (c) 1996 Robert van de Geijn and The University of Texas at Austin.
  See the file GNU_LICENSE for details on the gnu license

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 1, or (at your option)
  any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

  Written by:
  Robert van de Geijn, Department of Computer Sciences
  University of Texas at Austin  78712.    rvdg@cs.utexas.edu

***************************************************************************/



/* 
 * $Log: PLA_Copy.c,v $
 * Revision 1.26  1997/05/08 00:42:48  morrow
 * Changed the Mscalar_submscalar() calls so views do not go out of bounds.
 *
 * Revision 1.25  1997/05/04 02:25:43  overfelt
 * Somehow a break statement got deleted in one of those big switch/case
 * statements.
 *
 * Revision 1.24  1997/03/29 22:29:32  gunnels
 * Fixed the fact that in going from a column oriented object
 * to an mscalar (a matrix source) -- the case statement was wrong
 * and the copy to mscalar would never be called.
 *
 * Revision 1.23  1997/03/25 16:57:03  philip
 * Fixed the bug in pla_copy_misaligned
 *
 * Revision 1.20  1997/03/12 05:46:06  philip
 * Added clacpy and zlacpy where necessary.
 *
 * Revision 1.19  1997/03/11 22:41:39  overfelt
 * Inserted a macro to do a MPI_Barrier before an MPI_Allgather on the
 * Cray.  Don't know why this is needed, but it is.
 *
 * Revision 1.18  1997/03/07 14:55:48  gunnels
 * Added a necessary break; in PLA_Copy() [the switch function!]
 *
 * Revision 1.17  1997/03/06 17:14:24  philip
 * *** empty log message ***
 *
 * Revision 1.13  1997/02/20 21:41:05  philip
 * Added capability to copy misaligned objects
 *
 * Revision 1.12  1997/02/18 19:37:15  philip
 * *** empty log message ***
 *
 * Revision 1.11  1997/02/17 16:46:09  philip
 * *** empty log message ***
 *
 * Revision 1.10  1997/02/10 21:39:02  overfelt
 * Replaced the constant PLA_PANEL with two constants: PLA_PVECTOR and
 * PLA_PMVECTOR.
 *
 * Revision 1.9  1997/02/08 20:52:11  overfelt
 * Changed lots of #define statements.  Did not add or reduce functionality.
 * Just trying to make the code a little closer to The Book.
 *
 * A special tag "Before_Changing_define_Constants" was created so these
 * changes could be baked out if needed.
 *
 * Revision 1.8  1997/02/07 05:11:54  philip
 * Added multiscalar to multiscalar copy. philip
 *
 * Revision 1.7  1997/01/29 20:13:18  overfelt
 * Got this version from the Caltech machines.  It has a bug fix
 * about comparing "size" to "nb" which is documented at the top of
 * the code.
 *
 * Revision 1.6  1996/11/28  04:19:43  overfelt
 * Added check      size = (size < nb ? size : nb);
 * to PLA_Copy_mvector_rowmatrix.
 *
 * Revision 1.5  1996/11/27  05:11:33  philip
 * *** empty log message ***
 *
 * Revision 1.4  1996/11/14  04:38:53  overfelt
 * Cray hangs when a NULL pointer is passed to receive a zero length array.
 * So for buffers allocated for MPI_Scatterv always allocate at least one
 * element.  There is also a problem with broadcasting a zero length array
 * so do not call MPI_Bcast if the length to broadcast is zero.
 *
 * Also added the GNU header and the $Log: PLA_Copy.c,v $
 * Also added the GNU header and the Revision 1.26  1997/05/08 00:42:48  morrow
 * Also added the GNU header and the Changed the Mscalar_submscalar() calls so views do not go out of bounds.
 * Also added the GNU header and the
 * Also added the GNU header and the Revision 1.25  1997/05/04 02:25:43  overfelt
 * Also added the GNU header and the Somehow a break statement got deleted in one of those big switch/case
 * Also added the GNU header and the statements.
 * Also added the GNU header and the
 * Also added the GNU header and the Revision 1.24  1997/03/29 22:29:32  gunnels
 * Also added the GNU header and the Fixed the fact that in going from a column oriented object
 * Also added the GNU header and the to an mscalar (a matrix source) -- the case statement was wrong
 * Also added the GNU header and the and the copy to mscalar would never be called.
 * Also added the GNU header and the
 * Also added the GNU header and the Revision 1.23  1997/03/25 16:57:03  philip
 * Also added the GNU header and the Fixed the bug in pla_copy_misaligned
 * Also added the GNU header and the
 * Also added the GNU header and the Revision 1.20  1997/03/12 05:46:06  philip
 * Also added the GNU header and the Added clacpy and zlacpy where necessary.
 * Also added the GNU header and the
 * Also added the GNU header and the Revision 1.19  1997/03/11 22:41:39  overfelt
 * Also added the GNU header and the Inserted a macro to do a MPI_Barrier before an MPI_Allgather on the
 * Also added the GNU header and the Cray.  Don't know why this is needed, but it is.
 * Also added the GNU header and the
 * Also added the GNU header and the Revision 1.18  1997/03/07 14:55:48  gunnels
 * Also added the GNU header and the Added a necessary break; in PLA_Copy() [the switch function!]
 * Also added the GNU header and the
 * Also added the GNU header and the Revision 1.17  1997/03/06 17:14:24  philip
 * Also added the GNU header and the *** empty log message ***
 * Also added the GNU header and the
 * Also added the GNU header and the Revision 1.13  1997/02/20 21:41:05  philip
 * Also added the GNU header and the Added capability to copy misaligned objects
 * Also added the GNU header and the
 * Also added the GNU header and the Revision 1.12  1997/02/18 19:37:15  philip
 * Also added the GNU header and the *** empty log message ***
 * Also added the GNU header and the
 * Also added the GNU header and the Revision 1.11  1997/02/17 16:46:09  philip
 * Also added the GNU header and the *** empty log message ***
 * Also added the GNU header and the
 * Also added the GNU header and the Revision 1.10  1997/02/10 21:39:02  overfelt
 * Also added the GNU header and the Replaced the constant PLA_PANEL with two constants: PLA_PVECTOR and
 * Also added the GNU header and the PLA_PMVECTOR.
 * Also added the GNU header and the
 * Also added the GNU header and the Revision 1.9  1997/02/08 20:52:11  overfelt
 * Also added the GNU header and the Changed lots of #define statements.  Did not add or reduce functionality.
 * Also added the GNU header and the Just trying to make the code a little closer to The Book.
 * Also added the GNU header and the
 * Also added the GNU header and the A special tag "Before_Changing_define_Constants" was created so these
 * Also added the GNU header and the changes could be baked out if needed.
 * Also added the GNU header and the
 * Also added the GNU header and the Revision 1.8  1997/02/07 05:11:54  philip
 * Also added the GNU header and the Added multiscalar to multiscalar copy. philip
 * Also added the GNU header and the
 * Also added the GNU header and the Revision 1.7  1997/01/29 20:13:18  overfelt
 * Also added the GNU header and the Got this version from the Caltech machines.  It has a bug fix
 * Also added the GNU header and the about comparing "size" to "nb" which is documented at the top of
 * Also added the GNU header and the the code.
 * Also added the GNU header and the
 * Revision 1.6  1996/11/28  04:19:43  overfelt
 * Added check      size = (size < nb ? size : nb);
 * to PLA_Copy_mvector_rowmatrix.
 *
 * Revision 1.5  1996/11/27  05:11:33  philip
 * *** empty log message ***
 * entries.
 *
 */


#include "PLA.h"


static int FIRST_WARNING = 1;
static double PLA_DUMMY_ADRESS;

#if MANUFACTURE == CRAY
  #define PLA_CRAY_NULL_FIX( name ) ( ( name ) ? ( name ) : 1 )
  #define BF(buffer) (NULL==buffer) ? &PLA_DUMMY_ADRESS : buffer

  #define PLA_MPI_Allgatherv(a,b,c,d,e,f,g,h)   \
       do {                                     \
          MPI_Barrier( h );                     \
	  MPI_Allgatherv(a,b,c,d,e,f,g,h);      \
       } while(0)

#else
  #define PLA_CRAY_NULL_FIX( name )  name
  #define BF(buffer) buffer 
  #define PLA_MPI_Allgatherv(a,b,c,d,e,f,g,h)   \
	  MPI_Allgatherv    (a,b,c,d,e,f,g,h) 
#endif





int PLA_Pack_colpanel_mvector( PLA_Obj panel, PLA_Obj sendbuf,
			     int *sendcounts, int *displs)
/*
**************************************************************
  Packs the data from a matrix panel into a buffer suitable for 
  sending with MPI_Scatterv().  Also updates the displs[] and
  sendcounts[] arrays to reflect the packed data.

  Arguments :
  ---------------------------------------------------------------
  PLA_Obj panel               IN, the panel containing the data 
                                   to be packed.  This object has
				   PLA_Obj_obj_type = PLA_PROJ_ONTO_COL.

  PLA_Obj sendbuf             OUT, a multiscalar used to store
                                   the send buffer.  This must have
				   been allocated in the calling 
				   routine, and must be a N by 1 
				   multiscalar (where 
				   N >= npcols*locmax (see code 
				   for a definition of locmax).

  int *displs                  OUT, displs[i] contains the offset
                                   into the sendbuffer of the data
				   destined for column "i".  This
				   array must be allocated in the 
				   calling routine, and must be at 
				   least num_proc_cols long.

  int *sendcounts              OUT, sendcounts[i] contains the 
                                   number of elements destined for
				   column "i".  This
				   array must be allocated in the 
				   calling routine, and must be at 
				   least num_proc_cols long.

  Algorithm :
  ---------------------------------------------------------------

  1) The algorithm naturally divides into iterations each dealing with
  the topmost, largest contiguous block of rows that is contained on
  one row of processors.  Note that by definition, a column panel is
  contained entirely within one column of processors.  So the first
  step is to call PLA_Obj_top( panel, &size) and then do a
  PLA_Obj_horz_split_2( panel, size, &current_block, &remainder)

  2) Also, we need npcols (number of processor columns) views into the
  sendbuf.  view[i] initially points at the beginning of the i_th
  column's data in sendbuf.  (Note that senduf is allocated to contain
  locmax*npcols worth of storage).  As we proceed through the algorithm,
  view[i] is updated to point to the next unused portion of column
  i's part of the sendbuf.

  3) Copy the current_block's data into the current column's view of
  the sendbuf.
      
  4) If I am in the current row, update sendcounts[], and the current
  column's view into the sendbuf.

  5) Update the current vector destination (curdest = (curdest+1)%np);
      
  6) Finally, update current_panel <-- remainder.      


  ---------------------------------------------------------------
  Programmed by Greg Morrow
                morrow@physics.utexas.edu
**************************************************************
*/

{
  PLA_Obj 
    current_block = NULL, 
    remainder = NULL, 
    current_panel = NULL,
    sendbuf_view = NULL;

  PLA_Template g_template;
  
  int 
    locmax,
    i,
    g_length,
    g_width,
    g_align_row,
    g_align_col,
    current_proc_row,
    current_proc_col,
    current_vector_proc,
    nprows,
    npcols,
    myrow,
    idummy,
    nb, np, size,
    z_or_1;
  
  int 
    *local_lengths;

  void 
    *sendbuf_ptr;

  PLA_Template template;

  /* need to get nprows, npcols, myrow */
  PLA_Obj_template( panel, &g_template);
  PLA_Temp_comm_col_size( g_template, &nprows);
  PLA_Temp_comm_row_size( g_template, &npcols);
  PLA_Temp_comm_col_rank( g_template, &myrow);
  PLA_Temp_nb( g_template, &nb);
  PLA_Temp_zero_or_one( g_template, (PLA_Start_num *) &z_or_1);

  np = nprows*npcols;

  /* allocate an array for local vector lengths */
  local_lengths = (int *)pla_malloc(np*sizeof(int));
  
  PLA_Obj_global_all( panel, &g_length, &g_width, &g_align_row, &g_align_col);

  for(i=0;i<np;i++)
    PLA_Temp_vector_distant_length(g_template, 
				  i, 
				  g_length, 
				  g_align_row, 
				  &local_lengths[i]);

  /* locmax is the maximum number of elements any column will recv  */
  locmax = nb*g_width*( 1 + (1 + g_length/nb)/np);

  /* set up the displs[] array, zero the sendcounts[] array */
  for( i=0; i<npcols; i++)
    {
      displs[i] = i*locmax;
      sendcounts[ i] = 0;
    }


  /* need to get current_vector_proc (rank in comm1D of owner of first vector block) */
  PLA_Temp_vector_owner_rank(  g_template, g_align_row, &current_vector_proc);

  /* start current_panel as the whole panel */
  PLA_Matrix_submatrix( panel, PLA_DIM_ALL, PLA_DIM_ALL, 
		      PLA_ALIGN_FIRST, PLA_ALIGN_FIRST, &current_panel);
  
  for(;;)
    {
      /* get the size of the topmost contiguous block of rows */
      PLA_Obj_top( current_panel, &size, &current_proc_row);

      /* if there are no more rows, exit the loop */
      if( size == 0) break;

      /* split the current panel into its topmost contiguous block and a remainder */ 
      PLA_Obj_horz_split_2( current_panel, size, &current_block, &remainder);

      /* current_proc_col is the column of the current (vector) destination */
      current_proc_col = current_vector_proc/nprows;

      /* get the view into the sendbuf */
      PLA_Mscalar_submscalar( sendbuf, 
			    locmax - ((sendcounts[current_proc_col]/g_width) + z_or_1), 
			    PLA_DIM_ALL,
			    displs[ current_proc_col] + 
			    (sendcounts[current_proc_col]/g_width) + z_or_1, 
			    PLA_ALIGN_FIRST,
			    &sendbuf_view); 

      /* get the address of the buffer of the current view into the sendbuf */
      PLA_Obj_local_buffer( sendbuf_view, &sendbuf_ptr);
      
      /* copy the current block into the sendbuf */
      /* the leading dimension of local_lengths[current_vector_proc] causes */
      /* the send buffer to be packed in such a way that */      /*   1) the data for each node is packed contiguously, */
      /*   2) the data comes out in the right order so that it can */
      /*      simply be extracted into the destination object.  */
      PLA_Obj_extract_contents( current_block, 
				local_lengths[ current_vector_proc],
				1, 
				&idummy, 
				&idummy, 
				sendbuf_ptr);
      
      /* update the sendcounts array (for MPI_Scatterv()) */
      if( myrow==current_proc_row )
	{
	  sendcounts[ current_proc_col] += size*g_width;
	}

      /* update the vector destination */
      current_vector_proc = (current_vector_proc+1)%np;
      
      /* set up to work on the rest of the current panel in the next loop iteration */
      PLA_Obj_swap( &current_panel, &remainder);
    }

  /* free the views */
  PLA_Obj_free( &current_block);
  PLA_Obj_free( &remainder);
  PLA_Obj_free( &current_panel);
  PLA_Obj_free( &sendbuf_view);

  pla_free( local_lengths);
  return 0;
}



int PLA_Copy_colmatrix_mvector( PLA_Obj matrix, PLA_Obj mvector)
/******************************************************************
  Transforms a matrix into a multivector.  The matrix is NOT assumed
  to be contained within one column of processors.

  See the header for PLA_Copy() for a list of restrictions on 
  the inputs.


  Arguments :
  ---------------------------------------------------------------
  PLA_Obj matrix             IN, the matrix to be copied from
  PLA_LA_Obj mvector           OUT, the destination multivector 
                                  (must already be allocated large 
				  enough ).

  Algorithm :
  ---------------------------------------------------------------
  1)  The process naturally breaks down into steps each dealing with
      a block of columns that is the leftmost, largest contiguous 
      block stored on one column of processors.  So the first step is 
      to break off such a block using PLA_Obj_left(matrix, &size) and
      PLA_Obj_vert_split_2( matrix, size, &current_panel, &matrix_remainder).
      At this point, we also split the multivector vertically (same size) 
      into current_mvector and mvector_remainder.

  2)  The next step is to repack the data in current_panel so that
      the part to be sent to processor column "i" is located in a contiguous
      part of the send buffer.  This is accomplished with the call to
      PLA_Pack_colpanel_mvector( current_panel, sendbuf, sendcounts, displs).
      Note that this routine returns the displs and sendcounts arrays
      that are used by MPI_Scatterv().

  3)  Perform the scatter.

  4)  Copy the data from the receive buffer into the current view
      of the multivector (current_mvector).

  5)  To prepare for the next column panel, we do
      current_matrix <-- matrix_remainder and 
      current_mvector <-- mvector_remainder.


  ---------------------------------------------------------------
  Programmed by Greg Morrow, 04/01/96
                morrow@physics.utexas.edu
******************************************************************/ 
{
  

  PLA_Obj
    current_matrix = NULL,
    current_matrix_panel = NULL,
    matrix_remainder = NULL,

    current_mvector = NULL,
    current_mvector_panel = NULL,
    mvector_remainder = NULL,

    sendbuf = NULL,
    recvbuf = NULL,
    recv_buf_view = NULL;

  void  
    *send_buffer,   
    *recv_buffer,
    *current_mvector_buffer;

  int 
    *displs,
    *sendcounts;

  int 
    i,
    local_length_matrix,
    local_length_mvector,
    local_lld_mvector,
    global_length,
    locmax,
    idummy,
    nprows,
    npcols,
    owner_column,
    nb,
    size,
    recvcount,
    myrow,
    mycol,
    rows_extracted,
    cols_extracted,
    np;

  MPI_Datatype datatype;
  
  MPI_Comm comm_row;
  
  PLA_Template template;
  

  /* inquire about some necessary information */

  /* the datatype  */
  PLA_Obj_datatype( matrix, &datatype);

  /* the matrix and multivector local lengths, and the global length */
  PLA_Obj_local_length( matrix, &local_length_matrix);
  PLA_Obj_global_length( matrix, &global_length);
  PLA_Obj_local_length( mvector, &local_length_mvector);
  PLA_Obj_local_ldim( mvector, &local_lld_mvector);

  /* the template and template inquiries */
  PLA_Obj_template( matrix, &template);
  
  PLA_Temp_comm_row( template, &comm_row);
  PLA_Temp_nb( template, &nb);
  PLA_Temp_comm_col_size( template, &nprows);
  PLA_Temp_comm_row_size( template, &npcols);
  PLA_Temp_mycoords( template, &myrow, &mycol);
  
  np = nprows*npcols;

  /* locmax is the maximum number of elements any column will recv  */
  locmax = (nb*nprows)*(nb*( 1 + (1 + global_length/nb)/np));

  /* allocate space for the displs[] and sendcounts[] arrays */
  displs = (int *)pla_malloc( npcols*sizeof( int));
  sendcounts = (int *)pla_malloc( npcols*sizeof( int));
  
  
  /* create multiscalars for the send buffer and receive buffer, and get the addresses */
  PLA_Mscalar_create( datatype, PLA_ALL_ROWS, PLA_ALL_COLS,
		    locmax*npcols, 1, template, &sendbuf);
  PLA_Obj_local_buffer( sendbuf, &send_buffer);

  PLA_Mscalar_create( datatype, PLA_ALL_ROWS, PLA_ALL_COLS,
		     PLA_CRAY_NULL_FIX(local_length_mvector), 
                     nb*nprows, template, &recvbuf);
  PLA_Obj_local_buffer( recvbuf, &recv_buffer);
  
  /* initialize the current matrix and the current multivector to be all */
  PLA_Matrix_submatrix( matrix, PLA_DIM_ALL, PLA_DIM_ALL, 
		      PLA_ALIGN_FIRST, PLA_ALIGN_FIRST, &current_matrix);

  PLA_Mvector_submvector( mvector, PLA_DIM_ALL, PLA_DIM_ALL, 
			PLA_ALIGN_FIRST, PLA_ALIGN_FIRST, &current_mvector);

  for(;;)
    {
      /* find the size of the leftmost block of columns in the current matrix */
      PLA_Obj_left( current_matrix, &size, &owner_column);

      /* if no columns left, then exit */
      if( size == 0) break;
      
      /* split the current matrix into the current column panel and a remainder */
      PLA_Obj_vert_split_2( current_matrix, size, 
			    &current_matrix_panel, &matrix_remainder);
      
      /* split the current mutivector the same way*/
      PLA_Obj_vert_split_2( current_mvector, size, &current_mvector_panel, 
			  &mvector_remainder);

      /* pack the current matrix panel into a sendbuf */
      PLA_Pack_colpanel_mvector( current_matrix_panel, sendbuf, sendcounts, displs);

      /* how much data will I receive? */
      recvcount = sendcounts[ mycol];

      /* perform the scatter */
      MPI_Scatterv(BF(send_buffer), sendcounts, displs, datatype, 
		   BF(recv_buffer), recvcount, datatype, 
		   owner_column, comm_row);

      /* get the buffer of the current view into the target multivector */
      PLA_Obj_local_buffer( current_mvector_panel, &current_mvector_buffer);

      /* get a view into the recv buf */
      PLA_Mscalar_submscalar(recvbuf, 
			     local_length_mvector,
			     size, 
			     PLA_ALIGN_FIRST,
			     PLA_ALIGN_FIRST,
			     &recv_buf_view);

      /* copy the receive buffer into the multivector  */
      PLA_Obj_extract_contents( recv_buf_view, local_lld_mvector, 1, 
				&rows_extracted, &cols_extracted,
				current_mvector_buffer);

      /* update the views */
      PLA_Obj_swap( &current_matrix, &matrix_remainder);
      PLA_Obj_swap( &current_mvector, &mvector_remainder);
    }
  
  /* free all the views */
  PLA_Obj_free( &recv_buf_view);
  
  PLA_Obj_free( &current_matrix);
  PLA_Obj_free( &current_mvector);
  PLA_Obj_free( &current_matrix_panel);
  PLA_Obj_free( &current_mvector_panel);
  PLA_Obj_free( &matrix_remainder);
  PLA_Obj_free( &mvector_remainder);
  PLA_Obj_free( &sendbuf);
  PLA_Obj_free( &recvbuf);
   pla_free(displs);
   pla_free(sendcounts);

  return 0;
  
}  
      



int PLA_Pack_col_vector( PLA_Obj panel, PLA_Obj sendbuf,
			     int *sendcounts, int *displs)
/***************************************************************
  Packs the data from a matrix panel into a buffer suitable for 
  sending with MPI_Scatterv().  Also updates the displs[] and
  sendcounts[] arrays to reflect the packed data.

  Arguments :
  ---------------------------------------------------------------
  PLA_Obj panel               IN, the panel containing the data 
                                   to be packed.  This object has
				   PLA_Obj_obj_type = PLA_PROJ_ONTO_COL.

  PLA_Obj sendbuf             OUT, a multiscalar used to store
                                   the send buffer.  This must have
				   been allocated in the calling 
				   routine, and must be a N by 1 
				   multiscalar (where 
				   N >= npcols*locmax (see code 
				   for a definition of locmax).

  int *displs                  OUT, displs[i] contains the offset
                                   into the sendbuffer of the data
				   destined for column "i".  This
				   array must be allocated in the 
				   calling routine, and must be at 
				   least num_proc_cols long.

  int *sendcounts              OUT, sendcounts[i] contains the 
                                   number of elements destined for
				   column "i".  This
				   array must be allocated in the 
				   calling routine, and must be at 
				   least num_proc_cols long.

  Algorithm :
  ---------------------------------------------------------------

  1) The algorithm naturally divides into iterations each dealing with
  the topmost, largest contiguous block of rows that is contained on
  one row of processors.  Note that by definition, a column panel is
  contained entirely within one column of processors.  So the first
  step is to call PLA_Obj_top( panel, &size) and then do a
  PLA_Obj_horz_split_2( panel, size, &current_block, &remainder)

  2) Also, we need npcols (number of processor columns) views into the
  sendbuf.  view[i] initially points at the beginning of the i_th
  column's data in sendbuf.  (Note that senduf is allocated to contain
  locmax*npcols worth of storage).  As we proceed through the algorithm,
  view[i] is updated to point to the next unused portion of column
  i's part of the sendbuf.

  3) Copy the current_block's data into the current column's view of
  the sendbuf.
      
  4) If I am in the current row, update sendcounts[], and the current
  column's view into the sendbuf.

  5) Update the current vector destination (curdest = (curdest+1)%np);
      
  6) Finally, update current_panel <-- remainder.      


  ---------------------------------------------------------------
  Programmed by Greg Morrow
                morrow@physics.utexas.edu
***************************************************************/
{
  PLA_Obj 
    current_block = NULL, 
    remainder = NULL, 
    current_panel = NULL,
    sendbuf_view = NULL;

  PLA_Template g_template;
  
  int 
    locmax,
    i,
    g_length,
    g_width,
    g_align_row,
    g_align_col,
    current_proc_row,
    current_proc_col,
    current_vector_proc,
    nprows,
    npcols,
    myrow,
    mycol,
    idummy,
    nb, np, size,
    z_or_1;
  
  int 
    *local_lengths;

  void 
    *sendbuf_ptr;

  PLA_Template template;

  PLA_Obj_obj_type source_obj_type;

  PLA_Obj_objtype( panel, &source_obj_type);


  /* need to get nprows, npcols, myrow */
  PLA_Obj_template( panel, &g_template);
  PLA_Temp_comm_col_size( g_template, &nprows);
  PLA_Temp_comm_row_size( g_template, &npcols);
  PLA_Temp_comm_col_rank( g_template, &myrow);
  PLA_Temp_comm_row_rank( g_template, &mycol);
  PLA_Temp_nb( g_template, &nb);
  PLA_Temp_zero_or_one( g_template, (PLA_Start_num *) &z_or_1);

  np = nprows*npcols;

  /* allocate an array for local vector lengths */
  local_lengths = (int *)pla_malloc(np*sizeof(int));
  
  PLA_Obj_global_all( panel, &g_length, &g_width, &g_align_row, &g_align_col);

  for(i=0;i<np;i++)
    PLA_Temp_vector_distant_length(g_template, 
				  i, 
				  g_length, 
				  g_align_row, 
				  &local_lengths[i]);

  /* locmax is the maximum number of elements any column will recv  */
  locmax = nb*( 1 + (1 + g_length/nb)/np);

  /* set up the displs[] array, zero the sendcounts[] array */
  for( i=0; i<npcols; i++)
    {
      displs[i] = i*locmax;
      sendcounts[ i] = 0;
    }


  /* need to get current_vector_proc (rank in comm1D of owner of first vector block) */
  PLA_Temp_vector_owner_rank(  g_template, g_align_row, &current_vector_proc);

  /* start current_panel as the whole panel */
  if( PLA_MATRIX == source_obj_type)
    PLA_Matrix_submatrix( panel, PLA_DIM_ALL, PLA_DIM_ALL, 
			PLA_ALIGN_FIRST, PLA_ALIGN_FIRST, &current_panel);
  else /* PLA_PVECTOR || PLA_PMVECTOR == source_obj_type */
    PLA_Panel_subpanel( panel, PLA_DIM_ALL, PLA_DIM_ALL,
		      PLA_ALIGN_FIRST, PLA_ALIGN_FIRST, &current_panel);
    
  for(;;)
    {
      /* get the size of the topmost contiguous block of rows */
      PLA_Obj_top( current_panel, &size, &current_proc_row);

      /* if there are no more rows, exit the loop */
      if( size == 0) break;

      /* split the current panel into its topmost contiguous block and a remainder */ 
      PLA_Obj_horz_split_2( current_panel, size, &current_block, &remainder);

      /* current_proc_col is the column of the current (vector) destination */
      current_proc_col = current_vector_proc/nprows;

      /* get the view into the sendbuf */
      PLA_Mscalar_submscalar( sendbuf, 
			    locmax - (sendcounts[current_proc_col] + z_or_1), 
			    PLA_DIM_ALL,
			    displs[ current_proc_col] + 
			    sendcounts[current_proc_col] + z_or_1, 
			    PLA_ALIGN_FIRST,
			    &sendbuf_view); 

      /* get the address of the buffer of the current column's view into the sendbuf */
      PLA_Obj_local_buffer( sendbuf_view, &sendbuf_ptr);
      

      /* copy the current block into the sendbuf */
      /* the leading dimension of local_lengths[current_vector_proc] causes */
      /* the send buffer to be packed in such a way that */
      /*   1) the data for each node is packed contiguously, */
      /*   2) the data comes out in the right order so that it can */
      /*      simply be extracted into the destination object.  */
      if( current_proc_row == myrow) 
	PLA_Obj_extract_contents( current_block, 
				local_lengths[ current_vector_proc],
				1, 
				&idummy, 
				&idummy, 
				sendbuf_ptr);
      
      /* update the sendcounts array (for MPI_Scatterv()) */
      if( myrow==current_proc_row )
	{
	  sendcounts[ current_proc_col] += size;
	}

      /* update the vector destination */
      current_vector_proc = (current_vector_proc+1)%np;
      
      /* set up to work on the rest of the current panel in the next loop iteration */
      PLA_Obj_swap( &current_panel, &remainder);
    }

  /* free the views */
  PLA_Obj_free( &current_block);
  PLA_Obj_free( &remainder);
  PLA_Obj_free( &current_panel);
  PLA_Obj_free( &sendbuf_view);

  pla_free( local_lengths);
  return 0;
}



int PLA_Copy_col_vector( PLA_Obj matrix, PLA_Obj vector)
/******************************************************************
  Transforms a matrix into a multivector.  The matrix is NOT assumed
  to be contained within one column of processors.

  See the header for PLA_Copy() for a list of restrictions on 
  the inputs.


  Arguments :
  ---------------------------------------------------------------
  PLA_Obj matrix             IN, the matrix to be copied from
  PLA_LA_Obj vector           OUT, the destination multivector 
                                  (must already be allocated large 
				  enough ).

  Algorithm :
  ---------------------------------------------------------------
  1)  The process naturally breaks down into steps each dealing with
      a block of columns that is the leftmost, largest contiguous 
      block stored on one column of processors.  So the first step is 
      to break off such a block using PLA_Obj_left(matrix, &size) and
      PLA_Obj_vert_split_2( matrix, size, &current_panel, &matrix_remainder).
      At this point, we also split the multivector vertically (same size) 
      into current_vector and vector_remainder.

  2)  The next step is to repack the data in current_panel so that
      the part to be sent to processor column "i" is located in a contiguous
      part of the send buffer.  This is accomplished with the call to
      PLA_Pack_colpanel_vector( current_panel, sendbuf, sendcounts, displs).
      Note that this routine returns the displs and sendcounts arrays
      that are used by MPI_Scatterv().

  3)  Perform the scatter.

  4)  Copy the data from the receive buffer into the current view
      of the multivector (current_vector).

  5)  To prepare for the next column panel, we do
      current_matrix <-- matrix_remainder and 
      current_vector <-- vector_remainder.


  ---------------------------------------------------------------
  Programmed by Greg Morrow, 04/01/96
                morrow@physics.utexas.edu
******************************************************************/ 
{
  

  PLA_Obj
    sendbuf = NULL,
    recvbuf = NULL,
    recv_buf_view = NULL;

  void  
    *send_buffer,   
    *recv_buffer,
    *current_vector_buffer;

  int 
    *displs,
    *sendcounts;

  int 
    local_length_matrix,
    local_length_vector,
    local_stride_vector,
    global_length,
    locmax,
    idummy,
    nprows,
    npcols,
    owner_column,
    nb,
    size,
    recvcount,
    myrow,
    mycol,
    rows_extracted,
    cols_extracted,
    np;

  MPI_Datatype datatype;
  
  MPI_Comm comm_row;

  PLA_Obj_obj_type source_obj_type;
  
  PLA_Template template;
  

  /* inquire about some necessary information */

  /* source object type */
  PLA_Obj_objtype( matrix, &source_obj_type);

  /* the datatype  */
  PLA_Obj_datatype( matrix, &datatype);

  /* the matrix and multivector local lengths, and the global length */
  PLA_Obj_local_length( matrix, &local_length_matrix);
  PLA_Obj_global_length( matrix, &global_length);
  PLA_Obj_local_length( vector, &local_length_vector);
  PLA_Obj_local_stride( vector, &local_stride_vector);

  /* the template and template inquiries */
  PLA_Obj_template( matrix, &template);
  
  PLA_Temp_comm_row( template, &comm_row);
  PLA_Temp_nb( template, &nb);
  PLA_Temp_comm_col_size( template, &nprows);
  PLA_Temp_comm_row_size( template, &npcols);
  PLA_Temp_mycoords( template, &myrow, &mycol);
  
  np = nprows*npcols;

  /* locmax is the maximum number of elements any column will recv  */
  locmax = (nb*( 1 + (1 + global_length/nb)/np));

  /* allocate space for the displs[] and sendcounts[] arrays */
  displs = (int *)pla_malloc( npcols*sizeof( int));
  sendcounts = (int *)pla_malloc( npcols*sizeof( int));
  
  
  /* create multiscalars for the send buffer and receive buffer, and get the addresses */
  PLA_Mscalar_create( datatype, PLA_ALL_ROWS, PLA_ALL_COLS,
		     locmax*npcols, 1, template, &sendbuf);
  PLA_Obj_local_buffer( sendbuf, &send_buffer);

  PLA_Mscalar_create( datatype, PLA_ALL_ROWS, PLA_ALL_COLS,
		     PLA_CRAY_NULL_FIX(local_length_vector), 
                      1, template, &recvbuf);
  PLA_Obj_local_buffer( recvbuf, &recv_buffer);
  
  /* PLA_Obj_left() returns garbage for duplicated column panels, */
  /* so we just set owner_column to column 0 */
  if( PLA_MATRIX == source_obj_type)
    PLA_Obj_left( matrix, &idummy, &owner_column);
  else
    owner_column = 0;

  
  /* pack the current matrix panel into a sendbuf */
  PLA_Pack_col_vector( matrix, sendbuf, sendcounts, displs);
  
  /* how much data will I receive? */
  recvcount = sendcounts[ mycol];

  
  /* perform the scatter */
  MPI_Scatterv(BF(send_buffer), sendcounts, displs, datatype, 
	       BF(recv_buffer), recvcount, datatype, owner_column, comm_row);

  
  /* get the buffer of the target vector */
  PLA_Obj_local_buffer( vector, &current_vector_buffer);
  
  /* get a view into the recv buf */
  PLA_Mscalar_submscalar(recvbuf, 
			local_length_vector,
			1, 
			PLA_ALIGN_FIRST,
			PLA_ALIGN_FIRST,
			&recv_buf_view);
  
  /* copy the receive buffer into the multivector  */
  PLA_Obj_extract_contents( recv_buf_view, local_length_vector, local_stride_vector, 
			    &rows_extracted, &cols_extracted,
			    current_vector_buffer);
  
  /* free all the views */
  pla_free(displs);
  pla_free(sendcounts);
  PLA_Obj_free( &recv_buf_view);
  PLA_Obj_free( &sendbuf);
  PLA_Obj_free( &recvbuf);

  return 0;
  
}  
      





int PLA_Pack_rowpanel_mvector( PLA_Obj panel, PLA_Obj sendbuf,
			      int *sendcounts, int *displs)
/***************************************************************
  Packs the data from a matrix row panel into a buffer suitable for 
  sending with MPI_Scatterv().  Also updates the displs[] and
  sendcounts[] arrays to reflect the packed data.

  Arguments :
  Arguments :
  ---------------------------------------------------------------
  PLA_Obj panel               IN, the panel containing the data 
                                   to be packed.  This object has
				   PLA_Obj_obj_type = PLA_PROJ_ONTO_COL.

  PLA_Obj sendbuf             OUT, a multiscalar used to store
                                   the send buffer.  This must have
				   been allocated in the calling 
				   routine, and must be a N by 1 
				   multiscalar (where 
				   N >= npcols*locmax (see code 
				   for a definition of locmax).

  int *displs                  OUT, displs[i] contains the offset
                                   into the sendbuffer of the data
				   destined for column "i".  This
				   array must be allocated in the 
				   calling routine, and must be at 
				   least num_proc_cols long.

  int *sendcounts              OUT, sendcounts[i] contains the 
                                   number of elements destined for
				   column "i".  This
				   array must be allocated in the 
				   calling routine, and must be at 
				   least num_proc_cols long.

  Algorithm :
  ---------------------------------------------------------------

  1) The algorithm naturally divides into iterations each dealing with
  the topmost, largest contiguous block of rows that is contained on
  one row of processors.  Note that by definition, a row panel is
  contained entirely within one row of processors.  So the first
  step is to call PLA_Obj_top( panel, &size) and then do a
  PLA_Obj_horz_split_2( panel, size, &current_block, &remainder)

  2) We also need a view into the sendbuf, which we use to keep
  track of where to write the current block's data.  This view is
  updated each loop.

  3) Copy the current_block's data into the current view of
  the sendbuf.
      
  4) If I am in the current row, update sendcounts[].

  5) Update the current vector destination (curdest = (curdest+1)%np);
      
  6) Finally, update current_panel <-- remainder.      


  ---------------------------------------------------------------
  Programmed by Greg Morrow
                morrow@physics.utexas.edu
***************************************************************/
{
  PLA_Obj 
    current_block = NULL, 
    remainder = NULL, 
    current_panel = NULL,
    sendbuf_view = NULL;

  PLA_Template g_template;
  
  int 
    locmax,
    i,
    g_length,
    g_width,
    g_align_row,
    g_align_col,
    current_proc_row,
    current_proc_col,
    current_vector_proc,
    nprows,
    npcols,
    myrow,
    mycol,
    size,
    idummy,
    z_or_1,
    np,
    nb;
  

  int *local_lengths;
  
  void 
    *sendbuf_ptr;

  PLA_Template template;

  /* need to get nprows, npcols, myrow */
  PLA_Obj_template( panel, &g_template);
  PLA_Temp_comm_col_size( g_template, &nprows);
  PLA_Temp_comm_row_size( g_template, &npcols);
  PLA_Temp_mycoords( g_template, &myrow, &mycol);
  PLA_Temp_nb( g_template, &nb);
  PLA_Temp_zero_or_one( g_template, (PLA_Start_num *) &z_or_1);

  np = nprows*npcols;

  local_lengths = (int *)pla_malloc( np*sizeof(int));

  PLA_Obj_global_all( panel, &g_length, &g_width, &g_align_row, &g_align_col);

  for(i=0;i<np;i++)
    PLA_Temp_vector_distant_length(g_template, 
				  i, 
				  g_width, 
				  g_align_col, 
				  &local_lengths[i]);

  /* locmax is the maximum number of elements any row will recv  */
  locmax = nb*nb*( 1 + (1 + g_width/nb)/np);

  /* set up the displs[] array, zero the sendcounts[] array */
  for( i=0; i<nprows; i++)
    {
      displs[i] = i*locmax;
      sendcounts[ i] = 0;
    }

  /* need to get current_vector_proc (rank in comm1D of owner of first vector block) */
  PLA_Temp_vector_owner_rank(  g_template, g_align_col, &current_vector_proc);

  /* start current_panel as the whole panel */
  PLA_Matrix_submatrix( panel, PLA_DIM_ALL, PLA_DIM_ALL, 
		      PLA_ALIGN_FIRST, PLA_ALIGN_FIRST, &current_panel);
  
  for(;;)
    {
      /* get the size of the leftmost contiguous block of cols */
      PLA_Obj_left( current_panel, &size, &current_proc_col);

      /* if there are no more cols, exit the loop */
      if( size == 0) break;

      /* split the current panel into its leftmost contiguous block and a remainder */ 
      PLA_Obj_vert_split_2( current_panel, size, &current_block, &remainder);

      /* current_proc_row is the row of the current (vector) destination */
      current_proc_row = current_vector_proc%nprows;

      /* get the view into the sendbuf */
      PLA_Mscalar_submscalar( sendbuf, 
			     locmax - (sendcounts[current_proc_row]/g_length + z_or_1), 
			     1, 
			     displs[ current_proc_row] + 
			     sendcounts[current_proc_row]/g_length + z_or_1, 
			     PLA_ALIGN_FIRST, 
			     &sendbuf_view);

      /* get the address of the buffer of the current column's view into the sendbuf */
      PLA_Obj_local_buffer( sendbuf_view, &sendbuf_ptr);
      
      /* copy the current block into the sendbuf */
      if( mycol == current_proc_col)
	PLA_Obj_extract_transpose_contents( current_block, 
					    local_lengths[ current_vector_proc], 
					    1, &idummy, &idummy, 
					    sendbuf_ptr);
      
      /* update the sendcounts array (for MPI_Scatterv()) and update the */
      /* current column's view into the sendbuf */
      if( mycol==current_proc_col )
	{
	  sendcounts[ current_proc_row] += size*g_length;
	}

      /* update the vector destination */
      current_vector_proc = (current_vector_proc+1)%np;
      
      /* set up to work on the rest of the current panel in the next loop iteration */
      PLA_Obj_swap( &current_panel, &remainder);
    }

  /* free the views */
  PLA_Obj_free( &current_block);
  PLA_Obj_free( &remainder);
  PLA_Obj_free( &current_panel);
  PLA_Obj_free( &sendbuf_view);

  pla_free( local_lengths);
  
  return 0;
}




int PLA_Copy_rowmatrix_mvector( PLA_Obj matrix, PLA_Obj mvector)
/*************************************************************************
  Transform a row-oriented matrix into a multivector.

  The inputs must obey the restrictions documented in PLA_Copy().

  Arguments :
  ---------------------------------------------------------------
  PLA_Obj matrix             IN, the matrix to be copied from
  PLA_LA_Obj mvector           OUT, the destination multivector 
                                  (must already be allocated large 
				  enough ).

  Algorithm :
  ---------------------------------------------------------------
  1)  The process naturally breaks down into steps each dealing with
      a block of rows that is the topmost, largest contiguous 
      block stored on one row of processors.  So the first step is 
      to break off such a block using PLA_Obj_top(...,&size) and
      PLA_Obj_horz_split_2( matrix, size, &current_panel, &matrix_remainder).
      At this point, we also split the multivector vertically (same size) 
      into current_mvector and mvector_remainder.

  2)  The next step is to repack the data in current_panel so that
      the part to be sent to processor row "i" is located in a contiguous
      part of the send buffer.  This is accomplished with the call to
      PLA_Pack_rowpanel_mvector( current_panel, sendbuf, sendcounts, displs).
      Note that this routine returns the displs and sendcounts arrays
      that are used by MPI_Scatterv().

  3)  Perform the scatter.

  4)  Copy the data from the receive buffer into the current view
      of the multivector (current_mvector).

  5)  To prepare for the next column panel, we do
      current_matrix <-- matrix_remainder and 
      current_mvector <-- mvector_remainder.


  ---------------------------------------------------------------
  Programmed by Greg Morrow, 04/01/96
                morrow@physics.utexas.edu
  
***************************************************************************/     
{
  

  PLA_Obj
    current_matrix = NULL,
    current_matrix_panel = NULL,
    matrix_remainder = NULL,

    current_mvector = NULL,
    current_mvector_panel = NULL,
    mvector_remainder = NULL,

    sendbuf = NULL,
    recvbuf = NULL,
    recvbuf_view = NULL;

  void  
    *send_buffer = NULL,   
    *recv_buffer = NULL,
    *current_mvector_buffer = NULL,
    *recvbuf_view_ptr = NULL;

  int 
    *displs,
    *sendcounts;

  int 
    local_length_matrix,
    local_length_mvector,
    local_lld_mvector,
    global_width,
    idummy,
    nprows,
    owner_row,
    myrow,
    mycol,
    recvcount,
    size,
    locmax,
    nb,
    np;

  MPI_Datatype datatype;
  
  MPI_Comm comm_col;

  PLA_Template template;
  

  /* inquiries */

  /* the datatype  */
  PLA_Obj_datatype( matrix, &datatype);

  /* the matrix and multivector local lengths, and the global length */
  PLA_Obj_global_width ( matrix, &global_width);
  PLA_Obj_local_length ( mvector, &local_length_mvector);
  PLA_Obj_local_ldim ( mvector, &local_lld_mvector);

  /* the template */
  PLA_Obj_template( matrix, &template);

  PLA_Temp_comm_col( template, &comm_col);
  PLA_Temp_mycoords( template, &myrow, &mycol);
  PLA_Temp_nb( template, &nb);
  PLA_Temp_comm_col_size( template, &nprows);
  PLA_Temp_total_num_proc( template, &np);

  /* locmax is the maximum number of elements any column will recv in any loop */
  locmax = nb*nb*( 1 + (1 + global_width/nb)/np);

  /* allocate space for the displs[] and sendcounts[] array */
  displs = (int *)pla_malloc( nprows*sizeof( int));
  sendcounts = (int *)pla_malloc( nprows*sizeof( int));
  
  /* create multiscalars for the send buffer and receive buffer, and get the addresses */
  PLA_Mscalar_create( datatype, PLA_ALL_ROWS, PLA_ALL_COLS,
		     nprows*locmax, 1, template, &sendbuf);
  PLA_Obj_local_buffer( sendbuf, &send_buffer);

  PLA_Mscalar_create( datatype,PLA_ALL_ROWS, PLA_ALL_COLS, 
		     PLA_CRAY_NULL_FIX(nb*local_length_mvector), 
                     1, template, &recvbuf);
  PLA_Obj_local_buffer( recvbuf, &recv_buffer);
  
  /* initialize the current matrix and the current multivector to be all */
  PLA_Matrix_submatrix( matrix, PLA_DIM_ALL, PLA_DIM_ALL, 
		      PLA_ALIGN_FIRST, PLA_ALIGN_FIRST, &current_matrix);
  
  PLA_Mvector_submvector( mvector, PLA_DIM_ALL, PLA_DIM_ALL, 
			PLA_ALIGN_FIRST, PLA_ALIGN_FIRST, &current_mvector);

  for(;;)
    {
      /* find the size of the topmost block of rows in the current matrix */
      PLA_Obj_top( current_matrix, &size, &owner_row);
  
      /* if no rows left, then exit */
      if( size == 0) break;
      
      /* split the current matrix into the current row panel and a remainder */
      PLA_Obj_horz_split_2( current_matrix, size, 
			    &current_matrix_panel, &matrix_remainder);
      
      /* split the current mutivector vertically (vectors are always columns)*/
      PLA_Obj_vert_split_2( current_mvector, size, &current_mvector_panel, 
			  &mvector_remainder);
      
      /* pack the current matrix panel into a sendbuf */
      PLA_Pack_rowpanel_mvector( current_matrix_panel, sendbuf, sendcounts, displs);

      /* how much data will I receive? */
      recvcount = sendcounts[ myrow];

      /* perform the scatter */
      MPI_Scatterv(BF(send_buffer), sendcounts, displs, datatype, 
		   BF(recv_buffer), recvcount, datatype, owner_row, comm_col);

      /* get the buffer of the current view into the target multivector */
      PLA_Obj_local_buffer( current_mvector_panel, &current_mvector_buffer);

      /* get a view into the recvbuf */
      PLA_Mscalar_submscalar(recvbuf, 
			    recvcount,
			    1,
			    PLA_ALIGN_FIRST,
			    PLA_ALIGN_FIRST,
			    &recvbuf_view);

      /* get the address of the recvbuf_view's data */
      PLA_Obj_local_buffer( recvbuf_view, &recvbuf_view_ptr);

      /* copy the receive buffer into the multivector  */
      if( MPI_DOUBLE == datatype)
	{
	  PLA_dlacpy("General",
		  &local_length_mvector,
		  &size,
		  recvbuf_view_ptr,
		  &local_length_mvector,
		  current_mvector_buffer,
		  &local_lld_mvector);
	}
      else if (MPI_FLOAT == datatype)
	{
	  PLA_slacpy("General",
		  &local_length_mvector,
		  &size,
		  recvbuf_view_ptr,
		  &local_length_mvector,
		  current_mvector_buffer,
		  &local_lld_mvector);
	}
      else if (MPI_COMPLEX == datatype)
	{
	  PLA_clacpy("General",
		  &local_length_mvector,
		  &size,
		  recvbuf_view_ptr,
		  &local_length_mvector,
		  current_mvector_buffer,
		  &local_lld_mvector);
	}
      else if (MPI_DOUBLE_COMPLEX == datatype)
	{
	  PLA_zlacpy("General",
		  &local_length_mvector,
		  &size,
		  recvbuf_view_ptr,
		  &local_length_mvector,
		  current_mvector_buffer,
		  &local_lld_mvector);
	}
    
	  
      
      /* update the views */
      PLA_Obj_swap( &current_matrix, &matrix_remainder);
      PLA_Obj_swap( &current_mvector, &mvector_remainder);
    }
  
  /* free all the views */
  PLA_Obj_free( &current_matrix);
  PLA_Obj_free( &current_mvector);
  PLA_Obj_free( &current_matrix_panel);
  PLA_Obj_free( &current_mvector_panel);
  PLA_Obj_free( &matrix_remainder);
  PLA_Obj_free( &mvector_remainder);
  PLA_Obj_free( &sendbuf);
  PLA_Obj_free( &recvbuf);
  PLA_Obj_free( &recvbuf_view);
   pla_free(displs);
   pla_free(sendcounts);

  return 0;
  
}  



int PLA_Pack_row_vector( PLA_Obj panel, PLA_Obj sendbuf,
		       int *sendcounts, int *displs)
/***************************************************************
  Packs the data from a matrix row panel into a buffer suitable for 
  sending with MPI_Scatterv().  Also updates the displs[] and
  sendcounts[] arrays to reflect the packed data.

  Arguments :
  Arguments :
  ---------------------------------------------------------------
  PLA_Obj panel               IN, the panel containing the data 
                                   to be packed.  This object has
				   PLA_Obj_obj_type = PLA_PROJ_ONTO_COL.

  PLA_Obj sendbuf             OUT, a multiscalar used to store
                                   the send buffer.  This must have
				   been allocated in the calling 
				   routine, and must be a N by 1 
				   multiscalar (where 
				   N >= npcols*locmax (see code 
				   for a definition of locmax).

  int *displs                  OUT, displs[i] contains the offset
                                   into the sendbuffer of the data
				   destined for column "i".  This
				   array must be allocated in the 
				   calling routine, and must be at 
				   least num_proc_cols long.

  int *sendcounts              OUT, sendcounts[i] contains the 
                                   number of elements destined for
				   column "i".  This
				   array must be allocated in the 
				   calling routine, and must be at 
				   least num_proc_cols long.

  Algorithm :
  ---------------------------------------------------------------

  1) The algorithm naturally divides into iterations each dealing with
  the topmost, largest contiguous block of rows that is contained on
  one row of processors.  Note that by definition, a row panel is
  contained entirely within one row of processors.  So the first
  step is to call PLA_Obj_top( panel, &size) and then do a
  PLA_Obj_horz_split_2( panel, size, &current_block, &remainder)

  2) We also need a view into the sendbuf, which we use to keep
  track of where to write the current block's data.  This view is
  updated each loop.

  3) Copy the current_block's data into the current view of
  the sendbuf.
      
  4) If I am in the current row, update sendcounts[].

  5) Update the current vector destination (curdest = (curdest+1)%np);
      
  6) Finally, update current_panel <-- remainder.      


  ---------------------------------------------------------------
  Programmed by Greg Morrow
                morrow@physics.utexas.edu
***************************************************************/
{
  PLA_Obj 
    current_block = NULL, 
    remainder = NULL, 
    current_panel = NULL,
    sendbuf_view = NULL;

  PLA_Template g_template;
  
  int 
    locmax,
    i,
    g_length,
    g_width,
    g_align_row,
    g_align_col,
    current_proc_row,
    current_proc_col,
    current_vector_proc,
    nprows,
    npcols,
    myrow,
    mycol,
    size,
    idummy,
    z_or_1,
    np,
    nb;
  

  int *local_lengths;
  
  void 
    *sendbuf_ptr;

  PLA_Template template;

  /* need to get nprows, npcols, myrow */
  PLA_Obj_template( panel, &g_template);
  PLA_Temp_comm_col_size( g_template, &nprows);
  PLA_Temp_comm_row_size( g_template, &npcols);
  PLA_Temp_mycoords( g_template, &myrow, &mycol);
  PLA_Temp_nb( g_template, &nb);
  PLA_Temp_zero_or_one( g_template, (PLA_Start_num *) &z_or_1);

  np = nprows*npcols;

  local_lengths = (int *)pla_malloc( np*sizeof(int));

  PLA_Obj_global_all( panel, &g_length, &g_width, &g_align_row, &g_align_col);

  for(i=0;i<np;i++)
    PLA_Temp_vector_distant_length(g_template, 
				  i, 
				  g_width, 
				  g_align_col, 
				  &local_lengths[i]);

  /* locmax is the maximum number of elements any row will recv  */
  locmax = nb*( 1 + (1 + g_width/nb)/np);

  /* set up the displs[] array, zero the sendcounts[] array */
  for( i=0; i<nprows; i++)
    {
      displs[i] = i*locmax;
      sendcounts[ i] = 0;
    }

  /* need to get current_vector_proc (rank in comm1D of owner of first vector block) */
  PLA_Temp_vector_owner_rank(  g_template, g_align_col, &current_vector_proc);

  /* start current_panel as the whole panel */
  PLA_Matrix_submatrix( panel, PLA_DIM_ALL, PLA_DIM_ALL, 
		      PLA_ALIGN_FIRST, PLA_ALIGN_FIRST, &current_panel);
  
  for(;;)
    {
      /* get the size of the leftmost contiguous block of cols */
      PLA_Obj_left( current_panel, &size, &current_proc_col);

      /* if there are no more cols, exit the loop */
      if( size == 0) break;

      /* split the current panel into its leftmost contiguous block and a remainder */ 
      PLA_Obj_vert_split_2( current_panel, size, &current_block, &remainder);

      /* current_proc_row is the row of the current (vector) destination */
      current_proc_row = current_vector_proc%nprows;

      /* get the view into the sendbuf */
      PLA_Mscalar_submscalar( sendbuf, 
			     locmax - (sendcounts[current_proc_row] + z_or_1), 
			     1, 
			     displs[ current_proc_row] + 
			     sendcounts[current_proc_row] + z_or_1, 
			     PLA_ALIGN_FIRST, 
			     &sendbuf_view);

      /* get the address of the buffer of the current column's view into the sendbuf */
      PLA_Obj_local_buffer( sendbuf_view, &sendbuf_ptr);
      
      /* copy the current block into the sendbuf */
      if( mycol == current_proc_col)
	PLA_Obj_extract_transpose_contents( current_block, 
					    1,
					    1, &idummy, &idummy, 
					    sendbuf_ptr);

      /* update the sendcounts array (for MPI_Scatterv()) and update the */
      /* current column's view into the sendbuf */
      if( mycol==current_proc_col )
	{
	  sendcounts[ current_proc_row] += size;
	}

      /* update the vector destination */
      current_vector_proc = (current_vector_proc+1)%np;
      
      /* set up to work on the rest of the current panel in the next loop iteration */
      PLA_Obj_swap( &current_panel, &remainder);
    }

  /* free the views */
  PLA_Obj_free( &current_block);
  PLA_Obj_free( &remainder);
  PLA_Obj_free( &current_panel);
  PLA_Obj_free( &sendbuf_view);

  pla_free( local_lengths);
  
  return 0;
}




int PLA_Copy_row_vector( PLA_Obj matrix, PLA_Obj vector)
/*************************************************************************
  Transform a row-oriented matrix into a multivector.

  The inputs must obey the restrictions documented in PLA_Copy().

  Arguments :
  ---------------------------------------------------------------
  PLA_Obj matrix             IN, the matrix to be copied from
  PLA_LA_Obj vector           OUT, the destination multivector 
                                  (must already be allocated large 
				  enough ).

  Algorithm :
  ---------------------------------------------------------------
  1)  The process naturally breaks down into steps each dealing with
      a block of rows that is the topmost, largest contiguous 
      block stored on one row of processors.  So the first step is 
      to break off such a block using PLA_Obj_top(...,&size) and
      PLA_Obj_horz_split_2( matrix, size, &current_panel, &matrix_remainder).
      At this point, we also split the multivector vertically (same size) 
      into current_vector and vector_remainder.

  2)  The next step is to repack the data in current_panel so that
      the part to be sent to processor row "i" is located in a contiguous
      part of the send buffer.  This is accomplished with the call to
      PLA_Pack_rowpanel_vector( current_panel, sendbuf, sendcounts, displs).
      Note that this routine returns the displs and sendcounts arrays
      that are used by MPI_Scatterv().

  3)  Perform the scatter.

  4)  Copy the data from the receive buffer into the current view
      of the multivector (current_vector).

  5)  To prepare for the next column panel, we do
      current_matrix <-- matrix_remainder and 
      current_vector <-- vector_remainder.


  ---------------------------------------------------------------
  Programmed by Greg Morrow, 04/01/96
                morrow@physics.utexas.edu
  
***************************************************************************/     
{
  

  PLA_Obj
    sendbuf = NULL,
    recvbuf = NULL,
    recvbuf_view = NULL;

  void  
    *send_buffer = NULL,   
    *recv_buffer = NULL,
    *vector_buffer = NULL,
    *recvbuf_view_ptr = NULL;

  int 
    *displs,
    *sendcounts;

  int 
    local_length_matrix,
    local_length_vector,
    stride_vector,
    global_width,
    idummy,
    nprows,
    owner_row,
    myrow,
    mycol,
    recvcount,
    size,
    locmax,
    i_one = 1,
    error = 0,
    nb,
    np;

  MPI_Datatype datatype;
  
  MPI_Comm comm_col;

  PLA_Template template;
  

  /* inquiries */

  /* the datatype  */
  PLA_Obj_datatype( matrix, &datatype);

  /* the matrix and multivector local lengths, and the global length */
  PLA_Obj_global_width ( matrix, &global_width);
  PLA_Obj_local_length ( vector, &local_length_vector);
  PLA_Obj_local_stride ( vector, &stride_vector);

  /* the template */
  PLA_Obj_template( matrix, &template);

  PLA_Temp_comm_col( template, &comm_col);
  PLA_Temp_mycoords( template, &myrow, &mycol);
  PLA_Temp_nb( template, &nb);
  PLA_Temp_comm_col_size( template, &nprows);
  PLA_Temp_total_num_proc( template, &np);

  /* locmax is the maximum number of elements any column will recv in any loop */
  locmax = nb*( 1 + (1 + global_width/nb)/np);

  /* allocate space for the displs[] and sendcounts[] array */
  displs = (int *)pla_malloc( nprows*sizeof( int));
  sendcounts = (int *)pla_malloc( nprows*sizeof( int));

  PLA_Obj_top( matrix, &idummy, &owner_row); 
  
  /* create multiscalars for the send buffer and receive buffer, and get the addresses */
  PLA_Mscalar_create( datatype, PLA_ALL_ROWS, PLA_ALL_COLS,
		     nprows*locmax, 1, template, &sendbuf);
  PLA_Obj_local_buffer( sendbuf, &send_buffer);

  PLA_Mscalar_create( datatype, PLA_ALL_ROWS, PLA_ALL_COLS,
		     PLA_CRAY_NULL_FIX(local_length_vector), 
                     1, template, &recvbuf);
  PLA_Obj_local_buffer( recvbuf, &recv_buffer);
  
  /* pack the current matrix panel into a sendbuf */
  PLA_Pack_row_vector( matrix, sendbuf, sendcounts, displs);

  /* how much data will I receive? */
  recvcount = sendcounts[ myrow];

  /* perform the scatter */
  MPI_Scatterv(BF(send_buffer), sendcounts, displs, datatype, 
	       BF(recv_buffer), recvcount, datatype, owner_row, comm_col);

  /* get a view into the recvbuf */
  PLA_Mscalar_submscalar(recvbuf, 
			recvcount,
			1,
			PLA_ALIGN_FIRST,
			PLA_ALIGN_FIRST,
			&recvbuf_view);

  /* get the buffer of the target vector */
  PLA_Obj_local_buffer( vector, &vector_buffer);

  /* get the address of the recvbuf_view's data */
  PLA_Obj_local_buffer( recvbuf_view, &recvbuf_view_ptr);

  /* copy the receive buffer into the multivector  */
  PLA_Obj_extract_contents( recvbuf_view, recvcount, 1, &idummy, &idummy, vector_buffer);

  PLA_Obj_free( &sendbuf);
  PLA_Obj_free( &recvbuf);
  PLA_Obj_free( &recvbuf_view);
  pla_free(displs);
  pla_free(sendcounts);
  return 0;
  
}  
      


int PLA_Pack_mvector_colmatrix(PLA_Obj mvector, PLA_Obj sendbuf, 
			     int *recvcounts, int *displs)
/****************************************************************
  Packs a multivector for a Gather as executed by 
  PLA_Copy_mvector_colmatrix().  
  
  Arguments :
  PLA_Obj mvector                  IN, object to be packed
  PLA_Obj sendbuf                  OUT, multiscalar to hold send buf
  int *recvcounts                   OUT, array of message lengths
  int *displs                       OUT, array of message offsets

  Algorithm :
  (1) Set up the recvcounts[] and displs arrays.  THe method is to 
  make not only each receiving node's data contiguous, but also the
  entire message.

  (2) Extract the mvector into the sendbuf.

  Programmed by Greg Morrow, 04/15/96
  morrow@physics.utexas.edu
****************************************************************/
{
  int 
    g_width,
    g_length,
    g_align_col,
    g_align_row,
    local_length_mvector,
    local_width_mvector,
    z_or_1,
    myrank,
    idummy,
    size,
    myrow,
    mycol,
    nprows,
    npcols,
    rows_ex,
    cols_ex,
    i,
    current_rank,
    sendbuf_index;
  
  PLA_Template template;
  
  void *sendbuf_ptr = NULL;
  

  /* Inquiries */
  PLA_Obj_global_all( mvector, &g_length, &g_width, &g_align_row, &g_align_col);
  
  PLA_Obj_local_length( mvector, &local_length_mvector); 
  PLA_Obj_local_width( mvector, &local_width_mvector);
  

  PLA_Obj_template( mvector, &template);
  PLA_Temp_zero_or_one( template, (PLA_Start_num *)(&z_or_1));
  PLA_Temp_me1D( template, &myrank);
  PLA_Temp_comm_col_size( template, &nprows);
  PLA_Temp_comm_row_size( template, &npcols);
  PLA_Temp_mycoords( template, &myrow, &mycol);
  

  /* set up the recvcounts and displs arrays */

  /* the first message starts at displacement 0 */
  displs[ 0] = 0;

  /* how many rows will processor (myrow,0) own? */
  PLA_Temp_vector_distant_length( template, myrow,
				g_length, g_align_row, &recvcounts[0]);

  /* multiply by the width to get the proper count */
  recvcounts[0] *= g_width;

  for(i=1; i<npcols; i++)
    {
      /* find number of rows for next column */
      PLA_Temp_vector_distant_length( template, myrow+(i*nprows), 
				    g_length, g_align_row, &recvcounts[i]);
      recvcounts[i] *= g_width;

      /* this column's data begins just after the end of the last column's */ 
      displs[ i ] = displs[ i-1] + recvcounts[i-1];
    }

  /* get the pointer to the sendbuf view's data */
  PLA_Obj_local_buffer( sendbuf, &sendbuf_ptr);

  /* put the mvector data into the sendbuf */
  PLA_Obj_extract_contents( mvector, local_length_mvector, 1,
			    &rows_ex, &cols_ex, sendbuf_ptr);

  return 0;
  
}

int PLA_Unpack_mvector_colmatrix( PLA_Obj recvbuf, int *recvcounts, int *displs,
				PLA_Obj panel)
/********************************************************************************
  Unpack the data received from a gather into a matrix panel.

  Arguments:
  ---------
  PLA_Obj recvbuf                  IN, multiscalar that holds the data
  int *recvcounts                   IN, counts array as passed to MPI_Gatherv() 
  int *displs                       IN, displacement array as passed to MPI_Gatherv()
  PLA_Obj panel                    OUT, the matrix panel to be packed with data

  Algorithm:
  ---------
  (1)  Find the topmost block of the panel owned by a single row of nodes.

  (2)  Split off that part of the panel.

  (3)  Extract the data from the current portion of the recvbuffer into
       the panel.  See note below about use of xcopy().

  (4)  Proceed to deal with the rest of the panel.

  Note : This routine needed a bit more control over the memory copy
  than PLA_Obj_extract_contents() could provide, and so had to resort
  to xlacpy().  This is because each processor's portion of the recv buffer
  has its own leading dimension (which is just the local length of a mvector
  at the sending node times the width.)


  Programmed by Greg Morrow, 04/15/96
  morrow@physics.utexas.edu
***********************************************************************************/
{
  PLA_Obj
    current_panel = NULL,
    block = NULL,
    remainder = NULL,
    recvbuf_view = NULL;
  
  int 
    g_width,
    g_length,
    g_align_col,
    g_align_row,
    myrow,
    mycol,
    owner_row,
    owner_col,
    owner_rank,
    current_col,
    size,
    nprows,
    npcols,
    panel_lld,
    recvbuf_lld,
    idummy,
    block_length,
    block_width,
    np,
    z_or_1,
    cols_recvd,
    rows_recvd,
    i;

  PLA_Obj_obj_type
    dest_obj_type;

  void 
    *block_buffer = NULL,
    *recvbuf_view_ptr = NULL;

  PLA_Template template;

  MPI_Datatype datatype;
  
  
  /* Inquiries */

  PLA_Obj_template( panel, &template);

  PLA_Obj_datatype( panel, &datatype);

  PLA_Obj_objtype( panel, &dest_obj_type);
  
  PLA_Temp_mycoords( template, &myrow, &mycol);

  PLA_Obj_global_all( panel, &g_length, &g_width, &g_align_row, &g_align_col);

  PLA_Obj_local_ldim( panel, &panel_lld);
  
  /* who owns the first piece of the original mvector? (rank in comm1d) */
  /*  (this is used to determine the column rank of the original owner  */
  /*  of the current block) */
  PLA_Temp_vector_owner_rank( template, g_align_row, &owner_rank);

  PLA_Temp_comm_col_size( template, &nprows);
  PLA_Temp_comm_row_size( template, &npcols);
  np = nprows*npcols;

  PLA_Temp_zero_or_one( template, (PLA_Start_num *)(&z_or_1));

  PLA_Temp_matrix_owner_col( template, g_align_col, &owner_col);

  if( dest_obj_type == PLA_MATRIX)
    PLA_Matrix_submatrix( panel, PLA_DIM_ALL, PLA_DIM_ALL,
			PLA_ALIGN_FIRST, PLA_ALIGN_FIRST, &current_panel);

  else /* dest_obj_type == PLA_PVECTOR || PLA_PMVECTOR */
    PLA_Panel_subpanel( panel, PLA_DIM_ALL, PLA_DIM_ALL,
			PLA_ALIGN_FIRST, PLA_ALIGN_FIRST, &current_panel);

  for(;;)
    {
      /* topmost contiguous block of rows */
      PLA_Obj_top( current_panel, &size, &owner_row);

      
      /* quit if no more rows */
      if( 0 == size) break;

      /* find out which column this (vector) block originated in */
      current_col = owner_rank/nprows;
        
      /* break off the top block */
      PLA_Obj_horz_split_2( current_panel, size, &block, &remainder);

      /* swap the remainder with current_panel */
      PLA_Obj_swap( &current_panel, &remainder);


      /* get a view into the recvbuf, just big enough to contain */
      /* the current block's data, and starting at the current col's  */
      /* current offset in the recvbuf */
      PLA_Mscalar_submscalar( recvbuf,
			    size*g_width, 1,
			    displs[ current_col] + z_or_1,
			    PLA_ALIGN_FIRST,
			    &recvbuf_view);


      /* the buffer of that view */
      PLA_Obj_local_buffer( recvbuf_view, &recvbuf_view_ptr);
      
      /* get the address of the target block's buffer */
      PLA_Obj_local_buffer( block, &block_buffer);

      /* if I am in the owner row and (I'm in the owner col or destination */
      /* is a duplicated panel) */
      /* then extract then update displs[ current_col] */
      if( myrow == owner_row && 
         (mycol == owner_col || 
         dest_obj_type == PLA_PVECTOR ||
         dest_obj_type == PLA_PMVECTOR) )
	{
	  recvbuf_lld = recvcounts[ current_col]/g_width;
	  PLA_Obj_global_length( block, &block_length);
	  PLA_Obj_global_width( block, &block_width);
   
	  if( MPI_DOUBLE == datatype)
	    {
	      PLA_dlacpy("General", 
			 &block_length,
			 &block_width,
			 recvbuf_view_ptr,
			 &recvbuf_lld,
			 block_buffer,
			 &panel_lld);
	    }
	  else if( MPI_FLOAT == datatype)
	    {
	      PLA_slacpy("General", 
			 &block_length,
			 &block_width,
			 recvbuf_view_ptr,
			 &recvbuf_lld,
			 block_buffer,
			 &panel_lld);
	    }
	  else if (MPI_COMPLEX == datatype)
	    {
	      PLA_clacpy("General",
			 &block_length,
			 &block_width,
			 recvbuf_view_ptr,
			 &recvbuf_lld,
			 block_buffer,
			 &panel_lld);

	    }
	  else if (MPI_DOUBLE_COMPLEX == datatype)
	    {
	      PLA_zlacpy("General",
			 &block_length,
			 &block_width,
			 recvbuf_view_ptr,
			 &recvbuf_lld,
			 block_buffer,
			 &panel_lld);
	    }

	  /* update the displacement of the current column */
	  /* notice that since its column-major storage, we just move */
	  /* block_length steps */
	  displs[ current_col] += block_length;
	}
      /* update vector owner rank */
      owner_rank = (owner_rank+1)%np;

      
      
    }

  /* free all the PLA_Obj's */ 
  PLA_Obj_free( &block);
  PLA_Obj_free( &current_panel);
  PLA_Obj_free( &remainder);
  PLA_Obj_free( &recvbuf_view);
  

  return 0;
  
}


int PLA_Copy_mvector_colmatrix( PLA_Obj mvector, PLA_Obj matrix)
{
  PLA_Obj
    current_matrix = NULL,
    panel_matrix = NULL,
    remainder_matrix = NULL,
    current_mvector = NULL,
    panel_mvector = NULL,
    remainder_mvector = NULL,
    sendbuf = NULL,
    recvbuf = NULL;
  
  void 
    *sendbuf_ptr = NULL,
    *recvbuf_ptr = NULL;
  
  PLA_Template template;

  PLA_Obj_obj_type dest_obj_type;
  
  MPI_Datatype datatype;
  
  MPI_Comm comm_row;
  
  int 
    npcols,
    nprows,
    g_length_mvector,
    g_align_row_mvector,
    nb,
    np,
    local_length_mvector,
    local_max_length_mvector,
    size,
    myrow,
    mycol,
    mynode,
    i,
    owner_col;

  int 
    *displs,
    *recvcounts;
  

  
  
  /* Inquiries */
  PLA_Obj_template( mvector, &template);
  PLA_Temp_comm_row( template, &comm_row);
  PLA_Temp_comm_row_rank( template, &mycol);
  PLA_Temp_comm_col_rank( template, &myrow);
  PLA_Temp_comm_row_size( template, &npcols);
  PLA_Temp_comm_col_size( template, &nprows);
  PLA_Temp_nb( template, &nb);

  np = nprows*npcols;
  mynode = mycol*nprows + myrow;
  
  PLA_Obj_datatype( mvector, &datatype);
  PLA_Obj_local_length( mvector, &local_length_mvector);
  PLA_Obj_global_length( mvector, &g_length_mvector);
  PLA_Obj_global_align_row( mvector, &g_align_row_mvector);
  
  /* we need to distiguish between matrices and duplicated panels */
  PLA_Obj_objtype( matrix, &dest_obj_type);

  /* allocate memory for recvcounts and displs (MPI_Gatherv arrays) */
  displs = (int *)pla_malloc( npcols*sizeof( int));
  recvcounts = (int *)pla_malloc( npcols*sizeof( int));

  if( ! displs || !recvcounts)
    {
      printf("Cannot allocate memory in PLA_Copy_mvector_colmatrix()\n");
      return 1;
    }

  /* maximal local mvector length -- so we allocate enough memory for recvbuf */
  local_max_length_mvector = nb*(1 + (1 + g_length_mvector/nb)/nprows);

  /* create the send buf mscalar, and get its buffer */ 
  PLA_Mscalar_create( datatype, PLA_ALL_ROWS, PLA_ALL_COLS, 
		     local_length_mvector*nb, 1, template, &sendbuf);
  PLA_Obj_local_buffer( sendbuf, &sendbuf_ptr);

  /* create the recvbuf mscalar, and get its buffer */
  PLA_Mscalar_create( datatype, PLA_ALL_ROWS, PLA_ALL_COLS, 
		     local_max_length_mvector*nb*npcols, 1, template, &recvbuf);
  PLA_Obj_local_buffer( recvbuf, &recvbuf_ptr);
  
  if( PLA_MATRIX == dest_obj_type)
    PLA_Matrix_submatrix( matrix, PLA_DIM_ALL, PLA_DIM_ALL,
			PLA_ALIGN_FIRST, PLA_ALIGN_FIRST,
			&current_matrix);
  else /* PLA_PVECTOR || PLA_PMVECTOR == dest_obj_type */ 
    PLA_Panel_subpanel( matrix, PLA_DIM_ALL, PLA_DIM_ALL,
		      PLA_ALIGN_FIRST, PLA_ALIGN_FIRST,
		      &current_matrix);

  PLA_Mvector_submvector( mvector, PLA_DIM_ALL, PLA_DIM_ALL,
			PLA_ALIGN_FIRST, PLA_ALIGN_FIRST, &current_mvector);


  for(;;)
    {
      PLA_Obj_left( current_matrix, &size, &owner_col);

      size = (size < nb ? size : nb);

      if( 0 == size) break;
      
      PLA_Obj_vert_split_2( current_matrix, size, &panel_matrix, &remainder_matrix);

      PLA_Obj_vert_split_2( current_mvector, size, &panel_mvector, &remainder_mvector);
      
      PLA_Pack_mvector_colmatrix( panel_mvector, sendbuf, recvcounts, displs);

      
      if( PLA_MATRIX == dest_obj_type)
	MPI_Gatherv( BF(sendbuf_ptr), recvcounts[ mycol], datatype,
		     BF(recvbuf_ptr), recvcounts, displs, datatype, 
		     owner_col, comm_row);
      else /* PLA_PVECTOR || PLA_PMVECTOR == dest_obj_type */
	PLA_MPI_Allgatherv( BF(sendbuf_ptr), recvcounts[ mycol], datatype,
			BF(recvbuf_ptr), recvcounts, displs, datatype, 
			comm_row);


      PLA_Unpack_mvector_colmatrix( recvbuf, recvcounts, displs, panel_matrix);


      PLA_Obj_swap( &current_matrix, &remainder_matrix);
      PLA_Obj_swap( &current_mvector, &remainder_mvector);
    }
  
  PLA_Obj_free( &current_matrix);
  PLA_Obj_free( &panel_matrix);
  PLA_Obj_free( &remainder_matrix);
  PLA_Obj_free( &current_mvector);
  PLA_Obj_free( &panel_mvector);
  PLA_Obj_free( &remainder_mvector);
  PLA_Obj_free( &sendbuf);
  PLA_Obj_free( &recvbuf);

  pla_free( displs);
  pla_free( recvcounts);		 
  
  return 0;
}



int PLA_Pack_vector_col(PLA_Obj vector, PLA_Obj sendbuf, 
			     int *recvcounts, int *displs)
/****************************************************************
  Packs a multivector for a Gather as executed by 
  PLA_Copy_mvector_colmatrix().  
  
  Arguments :
  PLA_Obj mvector                  IN, object to be packed
  PLA_Obj sendbuf                  OUT, multiscalar to hold send buf
  int *recvcounts                   OUT, array of message lengths
  int *displs                       OUT, array of message offsets

  Algorithm :
  (1) Set up the recvcounts[] and displs arrays.  THe method is to 
  make not only each receiving node's data contiguous, but also the
  entire message.

  (2) Extract the mvector into the sendbuf.

  Programmed by Greg Morrow, 04/15/96
  morrow@physics.utexas.edu
****************************************************************/
{
  int 
    g_width,
    g_length,
    g_align_col,
    g_align_row,
    local_length_mvector,
    local_width_mvector,
    z_or_1,
    myrank,
    idummy,
    size,
    myrow,
    mycol,
    nprows,
    npcols,
    rows_ex,
    cols_ex,
    i,
    current_rank,
    sendbuf_index;
  
  PLA_Template template;
  
  void *sendbuf_ptr = NULL;
  

  /* Inquiries */
  PLA_Obj_global_all( vector, &g_length, &g_width, &g_align_row, &g_align_col);
  
  PLA_Obj_local_length( vector, &local_length_mvector); 
  PLA_Obj_local_width( vector, &local_width_mvector);
  

  PLA_Obj_template( vector, &template);
  PLA_Temp_zero_or_one( template, (PLA_Start_num *)(&z_or_1));
  PLA_Temp_me1D( template, &myrank);
  PLA_Temp_comm_col_size( template, &nprows);
  PLA_Temp_comm_row_size( template, &npcols);
  PLA_Temp_mycoords( template, &myrow, &mycol);
  

  /* set up the recvcounts and displs arrays */

  /* the first message starts at displacement 0 */
  displs[ 0] = 0;

  /* how many rows will processor (myrow,0) own? */
  PLA_Temp_vector_distant_length( template, myrow,
				g_length, g_align_row, &recvcounts[0]);

  /* multiply by the width to get the proper count */
  recvcounts[0] *= g_width;

  for(i=1; i<npcols; i++)
    {
      /* find number of rows for next column */
      PLA_Temp_vector_distant_length( template, myrow+(i*nprows), 
				    g_length, g_align_row, &recvcounts[i]);
      recvcounts[i] *= g_width;

      /* this column's data begins just after the end of the last column's */ 
      displs[ i ] = displs[ i-1] + recvcounts[i-1];
    }

  /* get the pointer to the sendbuf view's data */
  PLA_Obj_local_buffer( sendbuf, &sendbuf_ptr);

  /* put the vector data into the sendbuf */
  PLA_Obj_extract_contents( vector, local_length_mvector, 1,
			    &rows_ex, &cols_ex, sendbuf_ptr);

  return 0;
  
}

int PLA_Unpack_vector_col( PLA_Obj recvbuf, int *recvcounts, int *displs,
			 PLA_Obj panel)
/********************************************************************************
  Unpack the data received from a gather into a matrix panel.

  Arguments:
  ---------
  PLA_Obj recvbuf                  IN, multiscalar that holds the data
  int *recvcounts                   IN, counts array as passed to MPI_Gatherv() 
  int *displs                       IN, displacement array as passed to MPI_Gatherv()
  PLA_Obj panel                    OUT, the matrix panel to be packed with data

  Algorithm:
  ---------
  (1)  Find the topmost block of the panel owned by a single row of nodes.

  (2)  Split off that part of the panel.

  (3)  Extract the data from the current portion of the recvbuffer into
       the panel.  See note below about use of xcopy().

  (4)  Proceed to deal with the rest of the panel.

  Note : This routine needed a bit more control over the memory copy
  than PLA_Obj_extract_contents() could provide, and so had to resort
  to xlacpy().  This is because each processor's portion of the recv buffer
  has its own leading dimension (which is just the local length of a mvector
  at the sending node times the width.)


  Programmed by Greg Morrow, 04/15/96
  morrow@physics.utexas.edu
***********************************************************************************/
{
  PLA_Obj
    current_panel = NULL,
    block = NULL,
    remainder = NULL,
    recvbuf_view = NULL;
  
  int 
    g_width,
    g_length,
    g_align_col,
    g_align_row,
    myrow,
    mycol,
    owner_row,
    owner_col,
    owner_rank,
    current_col,
    size,
    nprows,
    npcols,
    panel_lld,
    recvbuf_lld,
    idummy,
    block_length,
    block_width,
    np,
    z_or_1,
    cols_recvd,
    rows_recvd;

  void 
    *block_buffer = NULL,
    *recvbuf_view_ptr = NULL;

  PLA_Template template;
  
  PLA_Obj_obj_type dest_obj_type;

  MPI_Datatype datatype;
  
  
  /* Inquiries */

  PLA_Obj_template( panel, &template);

  PLA_Obj_datatype( panel, &datatype);

  PLA_Obj_objtype( panel, &dest_obj_type);
  
  PLA_Temp_mycoords( template, &myrow, &mycol);

  PLA_Obj_global_all( panel, &g_length, &g_width, &g_align_row, &g_align_col);

  PLA_Obj_local_ldim( panel, &panel_lld);
  
  /* who owns the first piece of the original mvector? (rank in comm1d) */
  /*  (this is used to determine the column rank of the original owner  */
  /*  of the current block) */
  PLA_Temp_vector_owner_rank( template, g_align_row, &owner_rank);

  PLA_Temp_comm_col_size( template, &nprows);
  PLA_Temp_comm_row_size( template, &npcols);
  np = nprows*npcols;

  PLA_Temp_zero_or_one( template, (PLA_Start_num *)(&z_or_1));

  PLA_Temp_matrix_owner_col( template, g_align_col, &owner_col);

  if( PLA_MATRIX == dest_obj_type)
    PLA_Matrix_submatrix( panel, PLA_DIM_ALL, PLA_DIM_ALL,
			PLA_ALIGN_FIRST, PLA_ALIGN_FIRST, &current_panel);
  else /* PLA_PVECTOR || PLA_PMVECTOR */
    PLA_Panel_subpanel( panel, PLA_DIM_ALL, PLA_DIM_ALL,
		      PLA_ALIGN_FIRST, PLA_ALIGN_FIRST, &current_panel);
    
  
  for(;;)
    {
      /* topmost contiguous block of rows */
      PLA_Obj_top( current_panel, &size, &owner_row);
      
      /* quit if no more rows */
      if( 0 == size) break;

      /* find out which column this (vector) block originated in */
      current_col = owner_rank/nprows;
        
      /* break off the top block */
      PLA_Obj_horz_split_2( current_panel, size, &block, &remainder);

      /* swap the remainder with current_panel */
      PLA_Obj_swap( &current_panel, &remainder);


      /* get a view into the recvbuf, just big enough to contain */
      /* the current block's data, and starting at the current col's  */
      /* current offset in the recvbuf */
      PLA_Mscalar_submscalar( recvbuf,
			    size, 1,
			    displs[ current_col] + z_or_1,
			    PLA_ALIGN_FIRST,
			    &recvbuf_view);

      /* the buffer of that view */
      PLA_Obj_local_buffer( recvbuf_view, &recvbuf_view_ptr);
      
      /* get the address of the target block's buffer */
      PLA_Obj_local_buffer( block, &block_buffer);

      /* if I am in the owner row and col, extract then update displs[ current_col] */
      if( myrow == owner_row && 
         (mycol == owner_col || 
          PLA_PVECTOR==dest_obj_type ||
          PLA_PMVECTOR==dest_obj_type))
	{
	  PLA_Obj_extract_contents( recvbuf_view, panel_lld, 1, 
				    &idummy, &idummy, block_buffer);
	  
	  /* update the displacement of the current column */
	  displs[ current_col] += size;
	}
      /* update vector owner rank */
      owner_rank = (owner_rank+1)%np;
      
    }

  /* free all the PLA_Obj's */ 
  PLA_Obj_free( &block);
  PLA_Obj_free( &current_panel);
  PLA_Obj_free( &remainder);
  PLA_Obj_free( &recvbuf_view);
  

  return 0;
  
}


int PLA_Copy_vector_col( PLA_Obj vector, PLA_Obj matrix)
{
  PLA_Obj
    sendbuf = NULL,
    recvbuf = NULL;
  
  void 
    *sendbuf_ptr = NULL,
    *recvbuf_ptr = NULL;
  
  PLA_Template template;
  
  MPI_Datatype datatype;
  
  MPI_Comm comm_row;
  
  int 
    npcols,
    nprows,
    g_length_vector,
    g_align_row_vector,
    nb,
    np,
    local_length_vector,
    local_max_length_vector,
    size,
    myrow,
    mycol,
    owner_col;

  int 
    *displs,
    *recvcounts;

  PLA_Obj_obj_type dest_obj_type;
  

  
  
  /* Inquiries */
  PLA_Obj_template( vector, &template);
  PLA_Temp_comm_row( template, &comm_row);
  PLA_Temp_comm_row_rank( template, &mycol);
  PLA_Temp_comm_col_rank( template, &myrow);
  PLA_Temp_comm_row_size( template, &npcols);
  PLA_Temp_comm_col_size( template, &nprows);
  PLA_Temp_nb( template, &nb);
  PLA_Obj_objtype( matrix, &dest_obj_type);

  np = nprows*npcols;
  
  PLA_Obj_datatype( vector, &datatype);
  PLA_Obj_local_length( vector, &local_length_vector);
  PLA_Obj_global_length( vector, &g_length_vector);
  PLA_Obj_global_align_row( vector, &g_align_row_vector);
  
  

  /* allocate memory for recvcounts and displs (MPI_Gatherv arrays) */
  displs = (int *)pla_malloc( npcols*sizeof( int));
  recvcounts = (int *)pla_malloc( npcols*sizeof( int));

  if( ! displs || !recvcounts)
    {
      printf("Cannot allocate memory in PLA_Copy_vector_col()\n");
      return 1;
    }

  /* maximal local vector length -- so we allocate enough memory for recvbuf */
  local_max_length_vector = nb*(1 + (1 + g_length_vector/nb)/nprows);

  /* create the send buf mscalar, and get its buffer */ 
  PLA_Mscalar_create( datatype, PLA_ALL_ROWS, PLA_ALL_COLS,
		      PLA_CRAY_NULL_FIX(local_length_vector), 
		      1, template, &sendbuf);
  PLA_Obj_local_buffer( sendbuf, &sendbuf_ptr);

  /* create the recvbuf mscalar, and get its buffer */
  PLA_Mscalar_create( datatype, PLA_ALL_ROWS, PLA_ALL_COLS, 
		      PLA_CRAY_NULL_FIX(local_max_length_vector*npcols), 
		      1, template, &recvbuf);
  PLA_Obj_local_buffer( recvbuf, &recvbuf_ptr);

  /* which processor col owns the column */
  PLA_Obj_left( matrix, &size, &owner_col);
  
  /* pack the buffer and set up recvcounts */
  PLA_Pack_vector_col( vector, sendbuf, recvcounts, displs);

  if( PLA_MATRIX==dest_obj_type)
    MPI_Gatherv(BF(sendbuf_ptr), recvcounts[ mycol], datatype,
		BF(recvbuf_ptr), recvcounts, displs, datatype, owner_col, comm_row);
  else /* PLA_PVECTOR || PLA_PMVECTOR */
    PLA_MPI_Allgatherv(BF(sendbuf_ptr), recvcounts[ mycol], datatype,
		   BF(recvbuf_ptr), recvcounts, displs, datatype, comm_row);

  PLA_Unpack_vector_col( recvbuf, recvcounts, displs, matrix);
  
  PLA_Obj_free( &sendbuf);
  PLA_Obj_free( &recvbuf);

  pla_free( displs);
  pla_free( recvcounts);		 
  
  return 0;
}



int PLA_Pack_mvector_rowmatrix(PLA_Obj mvector, PLA_Obj sendbuf, 
			      int *recvcounts, int *displs)
/****************************************************************
  Packs a multivector for a Gather as executed by 
  PLA_Copy_mvector_rowmatrix().  
****************************************************************/
{
  int 
    g_width,
    g_length,
    g_align_col,
    g_align_row,
    local_length_mvector,
    local_width_mvector,
    z_or_1,
    myrank,
    idummy,
    size,
    myrow,
    mycol,
    nprows,
    npcols,
    rows_ex,
    cols_ex,
    i,
    current_rank,
    sendbuf_index;
  
  PLA_Template template;
  
  void *sendbuf_ptr = NULL;

  /* Inquiries */
  PLA_Obj_global_all( mvector, &g_length, &g_width, &g_align_row, &g_align_col);
  
  PLA_Obj_local_length( mvector, &local_length_mvector); 
  PLA_Obj_local_width( mvector, &local_width_mvector);
  

  PLA_Obj_template( mvector, &template);
  PLA_Temp_zero_or_one( template, (PLA_Start_num *)(&z_or_1));
  PLA_Temp_me1D( template, &myrank);
  PLA_Temp_comm_col_size( template, &nprows);
  PLA_Temp_comm_row_size( template, &npcols);
  PLA_Temp_mycoords( template, &myrow, &mycol);
  

  /* set up the recvcounts and displs arrays */
  displs[ 0] = 0;
  PLA_Temp_vector_distant_length( template, mycol*nprows,
				g_length, g_align_row, &recvcounts[0]);
  recvcounts[0] *= g_width;

  for(i=1; i<nprows; i++)
    {
      PLA_Temp_vector_distant_length( template, i+(mycol*nprows), 
				    g_length, g_align_row, &recvcounts[i]);
      recvcounts[i] *= g_width;
      displs[ i ] = displs[ i-1] + recvcounts[i-1];
    }

  /* get the pointer to the sendbuf view's data */
  PLA_Obj_local_buffer( sendbuf, &sendbuf_ptr);

  PLA_Obj_extract_transpose_contents( mvector, g_width, 1,
			    &rows_ex, &cols_ex, sendbuf_ptr);

  return 0;
  
}

int PLA_Unpack_mvector_rowmatrix( PLA_Obj recvbuf, int *recvcounts, int *displs,
				PLA_Obj panel)
{
  PLA_Obj
    current_panel = NULL,
    block = NULL,
    remainder = NULL,
    recvbuf_view = NULL;
  
  int 
    g_width,
    g_length,
    g_align_col,
    g_align_row,
    myrow,
    mycol,
    owner_row,
    owner_col,
    owner_rank,
    current_row,
    size,
    nprows,
    npcols,
    panel_lld,
    recvbuf_lld,
    idummy,
    block_length,
    block_width,
    np,
    z_or_1,
    cols_recvd,
    rows_recvd;

  void 
    *block_buffer = NULL,
    *recvbuf_view_ptr = NULL;

  PLA_Template template;

  PLA_Obj_obj_type 
    dest_obj_type; /* either PLA_PVECTOR || PLA_PMVECTOR or PLA_MATRIX */

  MPI_Datatype datatype;
  
  
  /* Inquiries */

  PLA_Obj_template( panel, &template);

  PLA_Obj_datatype( panel, &datatype);

  PLA_Obj_objtype( panel, &dest_obj_type);
  
  PLA_Temp_mycoords( template, &myrow, &mycol);

  PLA_Obj_global_all( panel, &g_length, &g_width, &g_align_row, &g_align_col);

  PLA_Obj_local_ldim( panel, &panel_lld);
  
  /* who owns the first piece of the original mvector? (rank in comm1d) */
  /*  (this is used to determine the column rank of the original owner  */
  /*  of the current block) */
  PLA_Temp_vector_owner_rank( template, g_align_col, &owner_rank);

  PLA_Temp_comm_col_size( template, &nprows);
  PLA_Temp_comm_row_size( template, &npcols);
  np = nprows*npcols;

  PLA_Temp_zero_or_one( template, (PLA_Start_num *)(&z_or_1));

  PLA_Temp_matrix_owner_row( template, g_align_row, &owner_row);

  if( PLA_MATRIX == dest_obj_type)
    PLA_Matrix_submatrix( panel, PLA_DIM_ALL, PLA_DIM_ALL,
			PLA_ALIGN_FIRST, PLA_ALIGN_FIRST, &current_panel);
  else /* PLA_PVECTOR || PLA_PMVECTOR == dest_obj_type */
    PLA_Panel_subpanel( panel, PLA_DIM_ALL, PLA_DIM_ALL,
			PLA_ALIGN_FIRST, PLA_ALIGN_FIRST, &current_panel);
  
  for(;;)
    {
      PLA_Obj_left( current_panel, &size, &owner_col);
      
      if( 0 == size) break;

      /* find out which row this block originated in */
      current_row = owner_rank%nprows;
        
      PLA_Obj_vert_split_2( current_panel, size, &block, &remainder);

      /* get a view into the recvbuf, just big enough to contain */
      /* the current block's data, and starting at the current col's  */
      /* current offset in the recvbuf */
      PLA_Mscalar_submscalar( recvbuf,
			    size*g_length, 1,
			    displs[ current_row] + z_or_1,
			    PLA_ALIGN_FIRST,
			    &recvbuf_view);

      /* get the address of the recvbuf_view's data */
      PLA_Obj_local_buffer( recvbuf_view, &recvbuf_view_ptr);
      
      /* get the address of the target block */
      PLA_Obj_local_buffer( block, &block_buffer);

      /* if I am in the owner row, extract and update displs[ current_col] */
      /* if panel is a duplicated panel, only insist on being in the current */
      /* row, not col */
      if( (myrow == owner_row || 
           dest_obj_type == PLA_PVECTOR ||
           dest_obj_type == PLA_PMVECTOR) &&  mycol == owner_col)
	{
	  recvbuf_lld = g_length;

	  if( MPI_DOUBLE == datatype)
	    {
	      
	      PLA_dlacpy("General", 
		      &g_length,
		      &size,
		      recvbuf_view_ptr,
		      &recvbuf_lld,
		      block_buffer,
		      &panel_lld);
	    }
	  else if( MPI_FLOAT == datatype)
	    {
	      PLA_slacpy("General", 
		      &g_length,
		      &size,
		      recvbuf_view_ptr,
		      &recvbuf_lld,
		      block_buffer,
		      &panel_lld);
	    }
	  else if (MPI_COMPLEX == datatype)
	    {
	      PLA_clacpy("General",
		      &g_length,
		      &size,
		      recvbuf_view_ptr,
		      &recvbuf_lld,
		      block_buffer,
		      &panel_lld);
	    }
	  else if(MPI_DOUBLE_COMPLEX == datatype)
	    {
	      PLA_zlacpy("General",
		      &g_length,
		      &size,
		      recvbuf_view_ptr,
		      &recvbuf_lld,
		      block_buffer,
		      &panel_lld);
	    }
	  
	  displs[ current_row] += g_length*size;
	}
      
      owner_rank = (owner_rank+1)%np;
      
      PLA_Obj_swap( &current_panel, &remainder);
    }
  PLA_Obj_free( &block);
  PLA_Obj_free( &current_panel);
  PLA_Obj_free( &remainder);
  PLA_Obj_free( &recvbuf_view);
  

  return 0;
  
}



int PLA_Copy_mvector_rowmatrix( PLA_Obj mvector, PLA_Obj matrix)
{
  PLA_Obj
    current_matrix = NULL,
    panel_matrix = NULL,
    remainder_matrix = NULL,
    current_mvector = NULL,
    panel_mvector = NULL,
    remainder_mvector = NULL,
    sendbuf = NULL,
    recvbuf = NULL;
  
  void 
    *sendbuf_ptr = NULL,
    *recvbuf_ptr = NULL;
  
  PLA_Template template;
  
  MPI_Datatype datatype;
  
  MPI_Comm comm_col;
  
  int 
    npcols,
    nprows,
    g_length_mvector,
    g_align_row_mvector,
    nb,
    np,
    local_length_mvector,
    local_max_length_mvector,
    size,
    myrow,
    mycol,
    owner_row;

  int 
    *displs,
    *recvcounts;
  
  PLA_Obj_obj_type 
    dest_obj_type; /* the type of the destination : 
                      either PLA_MATRIX or PLA_PVECTOR or PLA_PMVECTOR */
  
  
  /* Inquiries */
  PLA_Obj_template( mvector, &template);
  PLA_Obj_objtype( matrix, &dest_obj_type);
  PLA_Temp_comm_col( template, &comm_col);
  PLA_Temp_comm_row_rank( template, &mycol);
  PLA_Temp_comm_col_rank( template, &myrow);
  PLA_Temp_comm_row_size( template, &npcols);
  PLA_Temp_comm_col_size( template, &nprows);
  PLA_Temp_nb( template, &nb);

  np = nprows*npcols;
  
  PLA_Obj_datatype( mvector, &datatype);
  PLA_Obj_local_length( mvector, &local_length_mvector);
  PLA_Obj_global_length( mvector, &g_length_mvector);
  PLA_Obj_global_align_row( mvector, &g_align_row_mvector);
  

  /* allocate memory for recvcounts and displs (MPI_Gatherv arrays) */
  displs = (int *)pla_malloc( nprows*sizeof( int));
  recvcounts = (int *)pla_malloc( nprows*sizeof( int));

  if( ! displs || !recvcounts)
    {
      printf("Cannot allocate memory in PLA_Copy_mvector_colmatrix()\n");
      return 1;
    }

  /* maximal local mvector length -- so we allocate enough memory for recvbuf */

  local_max_length_mvector = nb*(1 + (1 + g_length_mvector/nb)/npcols);

  /* create the send buf mscalar, and get its buffer */ 
  PLA_Mscalar_create( datatype,PLA_ALL_ROWS, PLA_ALL_COLS, 
		     local_length_mvector*nb, 1, template, &sendbuf);
  PLA_Obj_local_buffer( sendbuf, &sendbuf_ptr);

  /* create the recvbuf mscalar, and get its buffer */
  PLA_Mscalar_create( datatype, PLA_ALL_ROWS, PLA_ALL_COLS,
		     local_max_length_mvector*nb*nprows, 1, template, &recvbuf);
  PLA_Obj_local_buffer( recvbuf, &recvbuf_ptr);
  
  if( PLA_MATRIX == dest_obj_type)
    {
      PLA_Matrix_submatrix( matrix, PLA_DIM_ALL, PLA_DIM_ALL,
			  PLA_ALIGN_FIRST, PLA_ALIGN_FIRST,
			  &current_matrix);
    }
  else /* (PLA_PVECTOR or PLA_PMVECTOR == dest_obj_type ) */
    {
      PLA_Panel_subpanel( matrix, PLA_DIM_ALL, PLA_DIM_ALL,
			PLA_ALIGN_FIRST, PLA_ALIGN_FIRST, &current_matrix);
    }

  PLA_Mvector_submvector( mvector, PLA_DIM_ALL, PLA_DIM_ALL,
			PLA_ALIGN_FIRST, PLA_ALIGN_FIRST, &current_mvector);

  for(;;)
    {
      PLA_Obj_top( current_matrix, &size, &owner_row);
      
      size = (size < nb ? size : nb);

      if( 0 == size) break;
      
      PLA_Obj_horz_split_2( current_matrix, size, &panel_matrix, &remainder_matrix);

      PLA_Obj_vert_split_2( current_mvector, size, &panel_mvector, &remainder_mvector);
      
      PLA_Pack_mvector_rowmatrix( panel_mvector, sendbuf, recvcounts, displs);

      if( PLA_MATRIX == dest_obj_type)
	{
	  MPI_Gatherv( BF(sendbuf_ptr), recvcounts[ myrow], datatype,
		       BF(recvbuf_ptr), recvcounts, displs, datatype, 
		       owner_row, comm_col);
	}
      else /* PLA_PVECTOR or PLA_PMVECTOR == dest_obj_type */
	{
	  PLA_MPI_Allgatherv( BF(sendbuf_ptr), recvcounts[ myrow], datatype,
	  		  BF(recvbuf_ptr), recvcounts, displs, datatype, 
			  comm_col);
	}

      PLA_Unpack_mvector_rowmatrix( recvbuf, recvcounts, displs, panel_matrix);
      
      PLA_Obj_swap( &current_matrix, &remainder_matrix);
      PLA_Obj_swap( &current_mvector, &remainder_mvector);
    }
  
  PLA_Obj_free( &current_matrix);
  PLA_Obj_free( &panel_matrix);
  PLA_Obj_free( &remainder_matrix);
  PLA_Obj_free( &current_mvector);
  PLA_Obj_free( &panel_mvector);
  PLA_Obj_free( &remainder_mvector);
  PLA_Obj_free( &sendbuf);
  PLA_Obj_free( &recvbuf);

  pla_free( displs);
  pla_free( recvcounts);		 
  
  return 0;
}




int PLA_Pack_vector_row(PLA_Obj vector, PLA_Obj sendbuf, 
			      int *recvcounts, int *displs)
/****************************************************************
  Packs a vector for a Gatherv as executed by 
  PLA_Copy_vector_row().  
****************************************************************/
{
  int 
    g_width,
    g_length,
    g_align_col,
    g_align_row,
    local_length_vector,
    local_width_vector,
    z_or_1,
    myrank,
    idummy,
    size,
    myrow,
    mycol,
    nprows,
    npcols,
    rows_ex,
    cols_ex,
    i,
    current_rank,
    sendbuf_index;
  
  PLA_Template template;
  
  void *sendbuf_ptr = NULL;

  /* Inquiries */
  PLA_Obj_global_all( vector, &g_length, &g_width, &g_align_row, &g_align_col);
  
  PLA_Obj_local_length( vector, &local_length_vector); 

  PLA_Obj_template( vector, &template);
  PLA_Temp_zero_or_one( template, (PLA_Start_num *)(&z_or_1));
  PLA_Temp_me1D( template, &myrank);
  PLA_Temp_comm_col_size( template, &nprows);
  PLA_Temp_comm_row_size( template, &npcols);
  PLA_Temp_mycoords( template, &myrow, &mycol);
  

  /* set up the recvcounts and displs arrays */

  /* first the top proc. in this col */
  displs[ 0] = 0;
  PLA_Temp_vector_distant_length( template, mycol*nprows,
				g_length, g_align_row, &recvcounts[0]);

  /* now the others in this proc. col */
  for(i=1; i<nprows; i++)
    {
      PLA_Temp_vector_distant_length( template, i+(mycol*nprows), 
				    g_length, g_align_row, &recvcounts[i]);
      displs[ i ] = displs[ i-1] + recvcounts[i-1];
    }

  /* get the pointer to the sendbuf view's data */
  PLA_Obj_local_buffer( sendbuf, &sendbuf_ptr);

  PLA_Obj_extract_contents( vector, 1, 1,
			    &rows_ex, &cols_ex, sendbuf_ptr);

  return 0;
  
}

int PLA_Unpack_vector_row( PLA_Obj recvbuf, int *recvcounts, int *displs,
				PLA_Obj panel)
{
  PLA_Obj
    current_panel = NULL,
    block = NULL,
    remainder = NULL,
    recvbuf_view = NULL;
  
  int 
    g_width,
    g_length,
    g_align_col,
    g_align_row,
    myrow,
    mycol,
    owner_row,
    owner_col,
    owner_rank,
    current_row,
    size,
    nprows,
    npcols,
    panel_lld,
    recvbuf_lld,
    idummy,
    block_length,
    block_width,
    np,
    z_or_1,
    cols_recvd,
    rows_recvd;

  void 
    *block_buffer = NULL,
    *recvbuf_view_ptr = NULL;

  PLA_Template template;

  PLA_Obj_obj_type dest_obj_type;

  MPI_Datatype datatype;
  
  
  /* Inquiries */

  PLA_Obj_template( panel, &template);

  PLA_Obj_datatype( panel, &datatype);

  PLA_Obj_objtype( panel, &dest_obj_type);
  
  PLA_Temp_mycoords( template, &myrow, &mycol);

  PLA_Obj_global_all( panel, &g_length, &g_width, &g_align_row, &g_align_col);

  PLA_Obj_local_ldim( panel, &panel_lld);
  
  /* who owns the first piece of the original mvector? (rank in comm1d) */
  /*  (this is used to determine the column rank of the original owner  */
  /*  of the current block) */
  PLA_Temp_vector_owner_rank( template, g_align_col, &owner_rank);

  PLA_Temp_comm_col_size( template, &nprows);
  PLA_Temp_comm_row_size( template, &npcols);
  np = nprows*npcols;

  PLA_Temp_zero_or_one( template, (PLA_Start_num *)(&z_or_1));

  PLA_Temp_matrix_owner_row( template, g_align_row, &owner_row);

  if( PLA_MATRIX == dest_obj_type)
    PLA_Matrix_submatrix( panel, PLA_DIM_ALL, PLA_DIM_ALL,
			PLA_ALIGN_FIRST, PLA_ALIGN_FIRST, &current_panel);
  else /* PLA_PVECTOR or PLA_PMVECTOR */
    PLA_Panel_subpanel( panel, PLA_DIM_ALL, PLA_DIM_ALL,
			PLA_ALIGN_FIRST, PLA_ALIGN_FIRST, &current_panel);
  
  for(;;)
    {
      PLA_Obj_left( current_panel, &size, &owner_col);
      if( 0 == size) break;

      /* find out which row this block originated in */
      current_row = owner_rank%nprows;
        
      PLA_Obj_vert_split_2( current_panel, size, &block, &remainder);

      /* get a view into the recvbuf, just big enough to contain */
      /* the current block's data, and starting at the current col's  */
      /* current offset in the recvbuf */
      PLA_Mscalar_submscalar( recvbuf,
			    size, 1,
			    displs[ current_row] + z_or_1,
			    PLA_ALIGN_FIRST,
			    &recvbuf_view);

      /* get the address of the recvbuf_view's data */
      PLA_Obj_local_buffer( recvbuf_view, &recvbuf_view_ptr);
      
      /* get the address of the target block */
      PLA_Obj_local_buffer( block, &block_buffer);

      /* if I am in the owner row, extract and update displs[ current_col] */
      if( (myrow == owner_row  || 
           PLA_PVECTOR==dest_obj_type ||
           PLA_PMVECTOR==dest_obj_type ) && mycol == owner_col)
	{

	  PLA_Obj_extract_contents(recvbuf_view,
				    panel_lld,
				    1,
				    &idummy, &idummy,
				    block_buffer);
	  displs[ current_row] += size;
	}
      owner_rank = (owner_rank+1)%np;

      PLA_Obj_swap( &current_panel, &remainder);
    }

  PLA_Obj_free( &block);
  PLA_Obj_free( &current_panel);
  PLA_Obj_free( &remainder);
  PLA_Obj_free( &recvbuf_view);
  

  return 0;
  
}



int PLA_Copy_vector_row( PLA_Obj vector, PLA_Obj matrix)
{
  PLA_Obj
    sendbuf = NULL,
    recvbuf = NULL;
  
  void 
    *sendbuf_ptr = NULL,
    *recvbuf_ptr = NULL;
  
  PLA_Template template;
  
  MPI_Datatype datatype;
  
  MPI_Comm comm_col;
  
  int 
    npcols,
    nprows,
    g_length_vector,
    g_align_row_vector,
    nb,
    np,
    local_length_vector,
    local_max_length_vector,
    size,
    myrow,
    mycol,
    owner_row;

  int 
    *displs,
    *recvcounts;

  PLA_Obj_obj_type dest_obj_type;
  

  
  
  /* Inquiries */
  PLA_Obj_template( vector, &template);
  PLA_Temp_comm_col( template, &comm_col);
  PLA_Temp_comm_row_rank( template, &mycol);
  PLA_Temp_comm_col_rank( template, &myrow);
  PLA_Temp_comm_row_size( template, &npcols);
  PLA_Temp_comm_col_size( template, &nprows);
  PLA_Temp_nb( template, &nb);
  PLA_Obj_objtype( matrix, &dest_obj_type);

  np = nprows*npcols;
  
  PLA_Obj_datatype( vector, &datatype);
  PLA_Obj_local_length( vector, &local_length_vector);
  PLA_Obj_global_length( vector, &g_length_vector);
  PLA_Obj_global_align_row( vector, &g_align_row_vector);
  

  /* allocate memory for recvcounts and displs (MPI_Gatherv arrays) */
  recvcounts = (int *)pla_malloc( nprows*sizeof( int));
  displs = (int *)pla_malloc( nprows*sizeof( int)); 

  if( ! displs || !recvcounts)
    {
      printf("Cannot allocate memory in PLA_Copy_vector_row()\n");
      return 1;
    }

  /* maximal local vector length -- so we allocate enough memory for recvbuf */
  local_max_length_vector = nb*(1 + (1 + g_length_vector/nb)/npcols);


  /* create the send buf mscalar, and get its buffer */ 
  PLA_Mscalar_create( datatype, PLA_ALL_ROWS, PLA_ALL_COLS,
		      PLA_CRAY_NULL_FIX(local_length_vector*nb), 
		      1, template, &sendbuf);
  PLA_Obj_local_buffer( sendbuf, &sendbuf_ptr);

  /* create the recvbuf mscalar, and get its buffer */
  PLA_Mscalar_create( datatype, PLA_ALL_ROWS, PLA_ALL_COLS,
		      PLA_CRAY_NULL_FIX(local_max_length_vector*nb*nprows), 
		      1, template, &recvbuf);
  PLA_Obj_local_buffer( recvbuf, &recvbuf_ptr);
  
  PLA_Obj_top( matrix, &size, &owner_row);
  
  PLA_Pack_vector_row( vector, sendbuf, recvcounts, displs);
  
  if( PLA_MATRIX == dest_obj_type )
    MPI_Gatherv( BF(sendbuf_ptr), recvcounts[ myrow], datatype,
		 BF(recvbuf_ptr), recvcounts, displs, datatype, 
		 owner_row, comm_col);
  else /* PLA_PVECTOR or PLA_PMVECTOR = dest_obj_type */
    PLA_MPI_Allgatherv( BF(sendbuf_ptr), recvcounts[ myrow], datatype,
		    BF(recvbuf_ptr), recvcounts, displs, datatype, comm_col);
    
  PLA_Unpack_vector_row( recvbuf, recvcounts, displs, matrix);
  
  PLA_Obj_free( &sendbuf);
  PLA_Obj_free( &recvbuf);
  
  pla_free( displs);
  pla_free( recvcounts);		 
  
  return 0;
}



int PLA_Copy_colmatrix_colpanel( PLA_Obj matrix, PLA_Obj panel)
{
  PLA_Obj
    current_matrix = NULL,
    block = NULL,
    remainder = NULL,
    current_panel = NULL,
    panel1 = NULL,
    panel2 = NULL,
    msgbuf = NULL,
    msgbuf_view = NULL;

  void 
    *panel_buffer = NULL,
    *msgbuf_ptr = NULL;

  int
    nb,
    size,
    owner_row,
    owner_col,
    panel_lld,
    rows,
    cols,
    local_length,
    mycol;

  MPI_Comm comm_row;

  MPI_Datatype datatype;

  PLA_Template template;

  PLA_Obj_template( matrix, &template);
  PLA_Obj_datatype( matrix, &datatype);

  PLA_Temp_comm_row( template, &comm_row);
  PLA_Temp_comm_row_rank( template, &mycol);

  PLA_Obj_local_length( matrix, &local_length);
  PLA_Obj_local_ldim( panel, &panel_lld);

  PLA_Temp_nb( template, &nb);
    


  /* create a multiscalar for the message buffer, just nb wide */
  PLA_Mscalar_create( datatype, PLA_ALL_ROWS, PLA_ALL_COLS,
		     local_length, nb, template, &msgbuf);
  PLA_Obj_local_buffer( msgbuf, &msgbuf_ptr);

  PLA_Matrix_submatrix( matrix, PLA_DIM_ALL, PLA_DIM_ALL,
		      PLA_ALIGN_FIRST, PLA_ALIGN_FIRST, &current_matrix);

  PLA_Panel_subpanel( panel, PLA_DIM_ALL, PLA_DIM_ALL,
		      PLA_ALIGN_FIRST, PLA_ALIGN_FIRST, &current_panel);

  for(;;)
    {
      PLA_Obj_left( current_matrix, &size, &owner_col);

      if( 0 == size ) break;

      PLA_Obj_vert_split_2( current_matrix, size, &block, &remainder);

      PLA_Obj_vert_split_2( current_panel, size, &panel1, &panel2);

      PLA_Obj_extract_contents( block, local_length, 1, 
				&rows, &cols, msgbuf_ptr);

      if (local_length)
         MPI_Bcast( BF(msgbuf_ptr), local_length*size, datatype, 
		    owner_col, comm_row);

      /* get a view of the message buffer multiscalar containing the recv'd data */
      PLA_Mscalar_submscalar( msgbuf, local_length, size,
			    PLA_ALIGN_FIRST, PLA_ALIGN_FIRST, &msgbuf_view);

      /* get the buffer of the current panel */
      PLA_Obj_local_buffer( panel1, &panel_buffer);

      /* sxtract the data from the msgbuffer to the panel */
      PLA_Obj_extract_contents( msgbuf_view, panel_lld, 1, 
				&rows, &cols, panel_buffer);

      /* swap the views to prepare for next loop */
      PLA_Obj_swap( &panel2, &current_panel);
      PLA_Obj_swap( &remainder, &current_matrix);
    }

  PLA_Obj_free( &current_matrix);
  PLA_Obj_free( &block);
  PLA_Obj_free( &remainder);
  PLA_Obj_free( &current_panel);
  PLA_Obj_free( &panel1);
  PLA_Obj_free( &panel2);
  PLA_Obj_free( &msgbuf);
  PLA_Obj_free( &msgbuf_view);

  return 0;
}




int PLA_Copy_rowmatrix_rowpanel( PLA_Obj matrix, PLA_Obj panel)
{
  PLA_Obj
    current_matrix = NULL,
    block = NULL,
    remainder = NULL,
    current_panel = NULL,
    panel1 = NULL,
    panel2 = NULL,
    msgbuf = NULL,
    msgbuf_view = NULL;

  void 
    *panel_buffer = NULL,
    *msgbuf_ptr = NULL;

  int
    nb,
    size,
    owner_row,
    owner_col,
    panel_lld,
    rows,
    cols,
    local_length,
    local_width,
    myrow,
    mycol;

  MPI_Comm comm_col;

  MPI_Datatype datatype;

  PLA_Template template;

  PLA_Obj_template( matrix, &template);
  PLA_Obj_datatype( matrix, &datatype);

  PLA_Temp_comm_col( template, &comm_col);
  PLA_Temp_comm_row_rank( template, &myrow);

  PLA_Obj_local_width( matrix, &local_width);
  PLA_Obj_local_ldim( panel, &panel_lld);

  PLA_Temp_nb( template, &nb);
    



  PLA_Matrix_submatrix( matrix, PLA_DIM_ALL, PLA_DIM_ALL,
		      PLA_ALIGN_FIRST, PLA_ALIGN_FIRST, &current_matrix);


  PLA_Panel_subpanel( panel, PLA_DIM_ALL, PLA_DIM_ALL,
		      PLA_ALIGN_FIRST, PLA_ALIGN_FIRST, &current_panel);

  for(;;)
    {
      PLA_Obj_top( current_matrix, &size, &owner_row);

      if( 0 == size ) break;

      PLA_Obj_horz_split_2( current_matrix, size, &block, &remainder);

      PLA_Obj_horz_split_2( current_panel, size, &panel1, &panel2);
      
      /* create a multiscalar for the message buffer, just size long by local_width wide */
      PLA_Mscalar_create( datatype, PLA_ALL_ROWS, PLA_ALL_COLS,
			 size, local_width, template, &msgbuf);
      PLA_Obj_local_buffer( msgbuf, &msgbuf_ptr);

      PLA_Obj_extract_contents( block, size, 1, 
				&rows, &cols, msgbuf_ptr); 

      if (local_width)
         MPI_Bcast( BF(msgbuf_ptr), local_width*size, datatype, 
		    owner_row, comm_col);

      /* get a view of the message buffer multiscalar containing the recv'd data */
      PLA_Mscalar_submscalar( msgbuf, size, local_width, 
			    PLA_ALIGN_FIRST, PLA_ALIGN_FIRST, &msgbuf_view);

      /* get the buffer of the current panel */
      PLA_Obj_local_buffer( panel1, &panel_buffer);

      /* sxtract the data from the msgbuffer to the panel */
      PLA_Obj_extract_contents( msgbuf_view, panel_lld, 1, 
				&rows, &cols, panel_buffer);

      /* swap the views to prepare for next loop */
      PLA_Obj_swap( &panel2, &current_panel);
      PLA_Obj_swap( &remainder, &current_matrix);

      /* this is created inside the loop, so has to be freed here */
      PLA_Obj_free( &msgbuf);
    }

  PLA_Obj_free( &current_matrix);
  PLA_Obj_free( &block);
  PLA_Obj_free( &remainder);
  PLA_Obj_free( &current_panel);
  PLA_Obj_free( &panel1);
  PLA_Obj_free( &panel2);
  PLA_Obj_free( &msgbuf_view);

  return 0;
}




int PLA_Copy_same_type( PLA_Obj source, PLA_Obj dest)
{
  void *dest_buffer;
  int rows_extracted, cols_extracted, dest_lld;
  
  PLA_Obj_local_buffer( dest, &dest_buffer);
  PLA_Obj_local_ldim( dest, &dest_lld);
  
  PLA_Obj_extract_contents( source, dest_lld, 1, 
			    &rows_extracted, &cols_extracted,
			    dest_buffer);
  
  return 0;
  
}


int PLA_Copy_rowmatrix_colmatrix( PLA_Obj source, PLA_Obj dest)
{
  PLA_Obj 
    mvector = NULL;
  
  int 
    g_width,
    g_length,
    g_align_col,
    g_align_row;
  
  PLA_Template template;
  
  MPI_Datatype datatype;
  
  PLA_Obj_global_all( dest, &g_length, &g_width, &g_align_row, &g_align_col);
  PLA_Obj_template( dest, &template);
  PLA_Obj_datatype( dest, &datatype);
  
  PLA_Mvector_create(datatype, g_length, g_width, 
		    template, g_align_row, &mvector);
  
  PLA_Copy_rowmatrix_mvector( source, mvector);
  PLA_Copy_mvector_colmatrix( mvector, dest);
  
  PLA_Obj_free(&mvector);
  return 0;
}


int PLA_Copy_colmatrix_rowmatrix( PLA_Obj source, PLA_Obj dest)
{
  PLA_Obj 
    mvector = NULL;
  
  int 
    g_width,
    g_length,
    g_align_col,
    g_align_row;
  
  PLA_Template template;
  
  MPI_Datatype datatype;
  
  PLA_Obj_global_all( source, &g_length, &g_width, &g_align_row, &g_align_col);
  PLA_Obj_template( dest, &template);
  PLA_Obj_datatype( dest, &datatype);
  
  PLA_Mvector_create(datatype, g_length, g_width, 
		    template, g_align_row, &mvector);
  
  PLA_Copy_colmatrix_mvector( source, mvector);
  PLA_Copy_mvector_rowmatrix( mvector, dest);

  PLA_Obj_free(&mvector);
  return 0;
}


#define ROW_ORIENTED -99
#define COL_ORIENTED -98
#define MSCALAR_CASE -97
int PLA_Copy_check_parameters( PLA_Obj source, PLA_Obj dest, int *error)
/******************************************************************
  Performs error checking on the inputs to PLA_Copy().

  The error codes are as follows :
  error code                         meaning
  ----------|-------------------------------
  0           no error
  1           Incompatible templates.  Templates are not equal.
  2           Mscalars detected.  Multiscalars are not 
              currently supported.
  3           Unequal datatypes.
  4           Incompatible dimensions (see below)
  5           Incompatible alignments (see below)


  Alignment and size restrictions.
  PLA_Copy() enforces alignment and size restrictions as follows.
  *) Both dimensions must be compatible.  'Compatible' here means
     that if a transpose is involved, then the row dimension of
     source must equal the column dimension of destination, and
     the column dimension of source must equal the row dimension
     of destination.  If there is no transpose involved, then
     the row dimensions must be equal and the column dimensions
     must be equal.

  *) For all cases, there is at least one alignment restriction.
     Any copy routine which involves a multivector (either explicitly
     or as an intermediate state) will lose some alignment information.
     So, for example, when copying from a column-oriented matrix
     to a multivector, only the row alignments are relevant, and
     they must be equal.  Similarly, when copying from a row-oriented
     matrix to a column-oriented matrix, the multivector is
     an intermediate state, and so only the column alignment of
     the row-matrix must match the row-alignment of the column matrix.

  *) For the case of copying from a column-matrix to a column-matrix,
     both alignments must be equal.  Similarly for row-matrix to 
     row-matrix.

******************************************************************/
{
  PLA_Panel_rowcol_flag
    source_panel_type,
    dest_panel_type;

  MPI_Datatype 
    source_datatype,
    dest_datatype;
  
  int 
    source_width,
    source_length,
    source_align_row,
    source_align_col,
    dest_width,
    dest_length,
    dest_align_row,
    dest_align_col,
    temp,
    source_orientation,
    dest_orientation;

  
  PLA_Obj_obj_type
    source_obj_type,
    dest_obj_type;

  PLA_Template 
    source_template,
    dest_template;
  
  PLA_Obj_template( source, &source_template);
  PLA_Obj_template( dest, &dest_template);

  if( source_template != dest_template)
    {
      printf("Incompatible templates in PLA_Copy()\n");
      *error = 1;
      return 0;
    }

  PLA_Obj_project_onto( source, &source_panel_type);
  PLA_Obj_project_onto( dest, &dest_panel_type);

  if (  (source_panel_type != PLA_PROJ_ONTO_COL) &&
	(source_panel_type != PLA_PROJ_ONTO_ROW)    )
    source_panel_type = PLA_PROJ_ONTO_COL;
  
  if (  (dest_panel_type != PLA_PROJ_ONTO_COL) &&
	(dest_panel_type != PLA_PROJ_ONTO_ROW)    )
    dest_panel_type = PLA_PROJ_ONTO_COL;

  PLA_Obj_objtype( source, &source_obj_type);
  PLA_Obj_objtype( dest, &dest_obj_type);

  PLA_Obj_datatype( source, &source_datatype);
  PLA_Obj_datatype( dest, &dest_datatype);

  if( source_datatype != dest_datatype)
    {
      printf("Incompatible datatypes in PLA_Copy()\n");
      *error = 3;
      return 0;
    }

  PLA_Obj_global_all( source, &source_length, &source_width, 
		      &source_align_row, &source_align_col);

  PLA_Obj_global_all( dest, &dest_length, &dest_width, 
		      &dest_align_row, &dest_align_col);


  if( (source_obj_type==PLA_MATRIX || 
       source_obj_type==PLA_PVECTOR  ||
       source_obj_type==PLA_PMVECTOR) &&
      source_panel_type == PLA_PROJ_ONTO_ROW)
    {
      source_orientation = ROW_ORIENTED;
    }
  else
    {
      source_orientation = COL_ORIENTED;
    }

  if( (dest_obj_type==PLA_MATRIX || 
       dest_obj_type==PLA_PVECTOR  ||
       dest_obj_type==PLA_PMVECTOR) &&
      dest_panel_type == PLA_PROJ_ONTO_ROW)
    {
      dest_orientation = ROW_ORIENTED;
    }
  else
    {
      dest_orientation = COL_ORIENTED;
    }
  

  if( (source_obj_type == PLA_MSCALAR) ||
      (dest_obj_type == PLA_MSCALAR) )
    source_orientation = MSCALAR_CASE;


  switch( source_orientation)
    {
    case MSCALAR_CASE:
      {
	if ( (source_panel_type == PLA_PROJ_ONTO_ROW) ||
	     (dest_panel_type == PLA_PROJ_ONTO_ROW) )
	  {
	    if( source_length != dest_width ||
		source_width != dest_length)
	      {
		printf("Incompatible dimensions in PLA_Copy()\n");
		*error = 4;
		return 0;
	      }
	  }
	else
	  if( source_length != dest_length ||
	      source_width != dest_width)
	    {
	      printf("Incompatible dimensions in PLA_Copy()\n");
	      *error = 4;
	      return 0;
	    } 
	break;
      }
    case ROW_ORIENTED:
      switch( dest_orientation)
	{
	case ROW_ORIENTED:
	  if( source_length != dest_length ||
	      source_width != dest_width)
	    {
	      printf("Incompatible dimensions in PLA_Copy()\n");
	      *error = 4;
	      return 0;
	    }
	  if( source_align_col != dest_align_col  ||
	     (source_obj_type == PLA_MATRIX && dest_obj_type == PLA_MATRIX &&
	      source_align_row != dest_align_row))
	    {
	      printf("Incompatible alignments in PLA_Copy()\n");
	      pla_copy_misaligned(source, dest );
	      *error = 5;
	      return 0;
	    }
	  break;
	case COL_ORIENTED:
	  if( source_length != dest_width ||
	      source_width != dest_length)
	    {
	      printf("Incompatible dimensions in PLA_Copy()\n");
	      *error = 4;
	      return 0;
	    }
	  if( source_align_col != dest_align_row )
	    {
	      printf("Incompatible alignments in PLA_Copy()\n");
	      pla_copy_misaligned(source,dest);
	      *error = 5;
	      return 0;
	    }
	  break;
	}
      break;
    case COL_ORIENTED:
      switch( dest_orientation)
	{
	case ROW_ORIENTED:
	  if( source_length != dest_width ||
	      source_width != dest_length)
	    {
	      printf("Incompatible dimensions in PLA_Copy()\n");
	      *error = 4;
	      return 0;
	    }
	  if( source_align_row != dest_align_col )
	    {
	      printf("Incompatible alignments in PLA_Copy()\n");
	      pla_copy_misaligned(source,dest);
	      *error = 5;
	      return 0;
	    }
	  break;
	case COL_ORIENTED:
	  if( source_length != dest_length ||
	      source_width != dest_width)
	    {
	      printf("Incompatible dimensions in PLA_Copy()\n");
	      *error = 4;
	      return 0;
	    }
	  if( source_align_row != dest_align_row  ||
	     (source_obj_type == PLA_MATRIX && dest_obj_type == PLA_MATRIX &&
	      source_align_col != dest_align_col))
	    {
	      printf("Incompatible alignments in PLA_Copy()\n");
	      pla_copy_misaligned(source,dest);
	      *error = 5;
	      return 0;
	    }
	  break;
	}
      break;
    }

  *error = 0;
  return 0;
}  

#undef ROW_ORIENTED
#undef COL_ORIENTED
#undef MSCALAR_CASE

int pla_copy_misaligned(PLA_Obj source, PLA_Obj dest)
{
  int 
    size, align1, align2, shift;
  int
    source_obj_type, dest_obj_type;
  int
    source_orientation, dest_orientation;
  PLA_Obj
    temp = NULL;

  PLA_Obj_objtype( source, &source_obj_type );
  PLA_Obj_objtype( dest, &dest_obj_type );

  if (source_obj_type != PLA_MVECTOR)
    {
      PLA_Obj_project_onto( source, &source_orientation );

      if (source_orientation == PLA_PROJ_ONTO_COL)
	PLA_Obj_global_width( source, &size );
      else
	PLA_Obj_global_length( source, &size );

      PLA_Mvector_create_conf_to( source, size, &temp );
      PLA_Copy(source, temp);
    }
  else
    PLA_Obj_swap( &source, &temp);

  PLA_Obj_project_onto( dest, &dest_orientation );
  
  if (dest_orientation == PLA_PROJ_ONTO_ROW )
    PLA_Obj_global_align_col( dest, &align2 );
  else
    PLA_Obj_global_align_row( dest, &align2 );

  PLA_Obj_global_align_row( temp, &align1 );
  shift = align2-align1;
  if (FIRST_WARNING){
    printf("copying misaligned objects, this warning would not be broadcasted again\n");
    FIRST_WARNING = 0;
  }

  pla_shift( &temp, shift);
  PLA_Copy( temp, dest);
  
  PLA_Obj_free( &temp );
  return(0);
}



int PLA_Copy( PLA_Obj source, PLA_Obj dest)
/**********************************************************************************
  Wrapper routine for the PLA_Copy facility.
  -->  Checks input PLA_Obj's for compatibility.
  -->  Calls the appropriate routine to process the copy.

  All the following restrictions are strictly enforced :
  1) source and destination global dimensions all equal
  2) source and destination global alignments compatible
  3) source and destination datatypes equal
  4) source and destination templates equal

  Note : for restriction (2), note that when a column-oriented matrix or any 
  multivector is copied to a rwo-oriented matrix, the alignment indices must 
  be transposes.  The same is true when copying from row matrices to column
  matrices or multivectors.
**********************************************************************************/
{
  PLA_Panel_rowcol_flag
    source_panel_type,
    dest_panel_type;

  int 
    error;
  
  PLA_Obj_obj_type
    source_obj_type,
    dest_obj_type;

  /* determine the panel type (only applicable for obj_type matrix) */
  PLA_Obj_project_onto( source, &source_panel_type);
  PLA_Obj_project_onto( dest, &dest_panel_type);

  /* determine the object type */
  PLA_Obj_objtype( source, &source_obj_type);
  PLA_Obj_objtype( dest, &dest_obj_type);

  /* do all the error checking */
  PLA_Copy_check_parameters( source, dest, &error); 

  if( error)
    {
      return error;
    } 
  
  /* a gnarly nest of switch statements to make the appropriate call */
  switch( source_obj_type)
    {
    case PLA_MATRIX:
    case PLA_PVECTOR: 
    case PLA_PMVECTOR:
      {
	switch( source_panel_type)
	  {
	  case PLA_PROJ_ONTO_ROW:
	    {
	      switch( dest_obj_type)
		{
		case PLA_VECTOR:
		  PLA_Copy_row_vector( source, dest);
		  break;
		case PLA_MVECTOR:
		  PLA_Copy_rowmatrix_mvector( source, dest);
		  break;
		case PLA_MATRIX:
		  switch( dest_panel_type)
		    {
		    case PLA_PROJ_ONTO_ROW:
		      PLA_Copy_same_type( source, dest);
		      break;
		    case PLA_PROJ_ONTO_COL:
		    default:
		      PLA_Copy_rowmatrix_colmatrix( source, dest);
		      break;
		    }
                  break;
		case PLA_PVECTOR: 
                case PLA_PMVECTOR:
		  switch( dest_panel_type )
		    {
		    case PLA_PROJ_ONTO_ROW:
		      switch( source_obj_type )
			{
			case PLA_MATRIX:
			  PLA_Copy_rowmatrix_rowpanel( source, dest);
			  break;
			case PLA_PVECTOR: 
                        case PLA_PMVECTOR:
			  PLA_Copy_same_type( source, dest);
			  break;
			}
		      break;
		      case PLA_PROJ_ONTO_COL:
		      /* notice we are piggybacking the PLA_PMVECTOR
                         and PLA_PVECTOR case on PLA_MATRIX */
			  PLA_Copy_rowmatrix_colmatrix( source, dest);
		      break;
		    }
                    break;
		case PLA_MSCALAR:
		  Copy_matrix_to_mscalar( source, dest);
		  break;
		}
	      break;
	    }
          /* break; JAG -- I stuck it here -- but it isn't needed */
	  case PLA_PROJ_ONTO_COL:
	  default:
	    {
	      switch( dest_obj_type)
		{
		case PLA_VECTOR:
		  PLA_Copy_col_vector( source, dest); 
		  break;
		case PLA_MVECTOR:
		  PLA_Copy_colmatrix_mvector( source, dest);
		  break;
		case PLA_MATRIX:
		  switch( dest_panel_type)
		    {
		    case PLA_PROJ_ONTO_ROW:
		      PLA_Copy_colmatrix_rowmatrix( source, dest);
		      break;
		    case PLA_PROJ_ONTO_COL:
		    default:
		      PLA_Copy_same_type( source, dest);
 		      break;
		    }
		  break;
		case PLA_PVECTOR: 
                case PLA_PMVECTOR:
		  switch( dest_panel_type)
		    {
		    case PLA_PROJ_ONTO_ROW:
		      /* piggy back on matrix */
		      PLA_Copy_colmatrix_rowmatrix( source, dest);
		      break;
		    case PLA_PROJ_ONTO_COL:
		      switch (source_obj_type)
			{
			case PLA_MATRIX:
			  PLA_Copy_colmatrix_colpanel( source, dest);
 			  break;
			case PLA_PVECTOR: case PLA_PMVECTOR:
			  PLA_Copy_same_type( source, dest);
			  break;
			}
                       break; /* Not really necessary */
                    }
		    break;
		case PLA_MSCALAR:
		      Copy_matrix_to_mscalar( source, dest);
		      break;
		}
	      break;
	    }
	  }
	break;
      }
      
    case PLA_MVECTOR:
      {
	switch( dest_obj_type)
	  {
	  case PLA_MSCALAR:
	    {
	      PLA_Copy_mvector_to_mscalar( source, dest );
	      break;
	    }
	  case PLA_MATRIX:
	  case PLA_PVECTOR: 
          case PLA_PMVECTOR:
	    {
	      switch( dest_panel_type)
		{
		case PLA_PROJ_ONTO_ROW:
		  PLA_Copy_mvector_rowmatrix( source, dest);
		  break;
		
		case PLA_PROJ_ONTO_COL:
		default:
		  PLA_Copy_mvector_colmatrix( source, dest);
		  break;
		}
	      break;
	    }

	  case PLA_MVECTOR:
	  case PLA_VECTOR:
	    {
	      PLA_Copy_same_type( source, dest);
	      break;
	    }
	    break;
	  }
	break;
      }

    case PLA_VECTOR:
      {
	switch( dest_obj_type)
	  {
	  case PLA_MSCALAR:
	    {
	      printf("vector to mscalar copy is not implemented yet\n");
	      printf("suggession: go with multivector of width 1\n");
	    }
	  case PLA_MATRIX:
	  case PLA_PVECTOR:
          case PLA_PMVECTOR:
	    {
	      switch( dest_panel_type)
		{
		case PLA_PROJ_ONTO_ROW:
		  PLA_Copy_vector_row( source, dest);
		  break;
		
		case PLA_PROJ_ONTO_COL:
		default:
		  PLA_Copy_vector_col( source, dest); 
		  break;
		}
	      break;
	    }
	  case PLA_MVECTOR:
	  case PLA_VECTOR:
	    {
	      PLA_Copy_same_type( source, dest);
	      break;
	    }
	    break;
	  }
	 break;
      }
     
    case PLA_MSCALAR:
      {
	switch(dest_obj_type)
	  {
	  case PLA_MSCALAR:
	    {
	      Copy_mscalar_to_mscalar(source, dest);
	      break;
	    }
	  case PLA_MVECTOR:
	    {
	      PLA_Copy_mscalar_to_mvector( source, dest );
	      break;
	    }
	  case PLA_MATRIX:
	  case PLA_PMVECTOR:
	  case PLA_PVECTOR:
	    {
	      Copy_mscalar_to_matrix( source, dest );
	      break;
	    }
	  break;
	  }
      break;
      }
    break;
    }
return 0;
}






