#include "PLA.h"


int PLA_Unpack_colpanel_mvector_opt( PLA_Obj p, PLA_Obj mv)
{
  PLA_Template template;
  
  
  int 
    i, me,
    ione = 1,
    idummy,
    total = 0,
    npcols,
    nprows,
    nb,
    mv_lld, p_lld,
    size, tsize, width_mv, local_mv_length,
    owner_top_1D, owner_bottom_1D, 
    myrow, mycol, owner_col, owner_row;

  void *mv_ptr = NULL, *p_ptr = NULL;

  /* Inquiries */

  PLA_Obj_template( mv, &template);
  PLA_Temp_comm_row_size( template, &npcols);
  PLA_Temp_comm_col_size( template, &nprows);
  PLA_Temp_comm_row_rank( template, &mycol);
  PLA_Temp_comm_col_rank( template, &myrow);

  PLA_Temp_nb( template, &nb);
  PLA_Temp_me1D( template, &me);

  PLA_Obj_local_length(mv, &local_mv_length);
  PLA_Obj_global_width( mv, &width_mv);
  PLA_Obj_local_ldim( p, &p_lld);
  PLA_Obj_local_ldim( mv, &mv_lld);

  PLA_Obj_local_buffer(mv, &mv_ptr);
  PLA_Obj_local_buffer(p, &p_ptr);
  PLA_Obj_top(mv, &size, &owner_top_1D);
  owner_col = owner_top_1D/nprows;
  owner_row = owner_top_1D%nprows;

  if (me == owner_top_1D)
    {
 /* if i own the possible first partial block */
      PLA_dlacpy( "G", &size, &width_mv,
		 p_ptr, &p_lld, mv_ptr, &mv_lld );
      p_ptr = (void *)((char *)p_ptr +
			     (size+nb*(npcols-1)) * sizeof(double));

      mv_ptr = (void *)((char *)mv_ptr + 
			size * sizeof(double));
      total = size;
    }

  /* set pointers to the beginning of the target data */
  else if(myrow == owner_row)
    {
      p_ptr = (void *)((char *)p_ptr +
		       (size+nb*((mycol + npcols - owner_col-1)%npcols))
		       * sizeof(double));
      total = 0;
    }
  else if(myrow > owner_row)
    {
      p_ptr = (void *)((char *)p_ptr +
		       (nb*((mycol + npcols - owner_col)%npcols))
		       * sizeof(double));
      total = 0;
    }
  else
    {
      p_ptr = (void *)((char *)p_ptr +
		       (nb*((mycol+npcols - owner_col-1)%npcols))
		       * sizeof(double));
      total = 0;
    }

  /* now jump right into copying */
  for(i=total; i<=local_mv_length-nb; i=i+nb){
    PLA_dlacpy("G", &nb, &width_mv, 
	       p_ptr, &p_lld, mv_ptr, &mv_lld );
    p_ptr = (void *)((char *)p_ptr +
		     (npcols)*nb*sizeof(double));
    mv_ptr = (void *)((char *)mv_ptr +
		      nb*sizeof(double));
  }

  /*take care of the possible last partial block */
  PLA_Obj_bottom(mv, &size, &owner_bottom_1D);

  if ( i != local_mv_length ) 
    {
/*      
   printf("size = %d, row = %d, col = %d, i = %d, llv = %d \n",
	     size, owner_row, owner_col, i, local_mv_length);
	*/    
      PLA_dlacpy("G", &size, &width_mv,
		 p_ptr, &p_lld, mv_ptr, &mv_lld );      
    }

return(0);
}
