#include <mpi.h>
#include <PLA.h>
#include <MISC_DEFS.h>
#include "PRISM.h"

void PRISM_map_half(PLA_Obj X, int *n_0, int *n_half, int *n_1) {
/*
   Map eigenvalues away from 1/2.

   if (n_1 > N_0)
      X = 2 * X**2 - X
   else
      3 * X - 2 * X**2

   THIS CODE NEEDS TO BE TESTED!!!
*/
   double value;
   PLA_Obj alpha=NULL, temp=NULL;
   MPI_Datatype datatype;
   PLA_Template template;

   /* Check conditions */
   if (*n_half == 0) return;

   /* Extract info from matrix X */
   PLA_Obj_datatype( X, &datatype );
   PLA_Obj_template( X, &template );

   /* Create temporary objects */
   PLA_Mscalar_create( datatype, PLA_ALL_ROWS, PLA_ALL_COLS,
       1, 1, template, &alpha );
   PLA_Matrix_create_conf_to( X, &temp );
   PLA_Obj_set_to_zero( temp );

   if ( *n_1 > *n_0 ) {
      /* more eigenvalues at 1 so map 1/2 to 0 */ 
      value = 2.;
      PLA_Obj_set( alpha, datatype, &value );
      PLA_Gemm( PLA_NO_TRANS, PLA_NO_TRANS, alpha, X, X, PRISM_zero, temp );
      PLA_Scal( PRISM_mone, X );
      PLA_Local_axpy( PRISM_one, temp, X );
      *n_0 += *n_half;
      *n_half = 0;
   } else {
      /* more eigenvalues at 0 so map 1/2 to 1 */ 
      value = -2.;
      PLA_Obj_set( alpha, datatype, &value );
      PLA_Gemm( PLA_NO_TRANS, PLA_NO_TRANS, alpha, X, X, PRISM_zero, temp );
      value = 3.;
      PLA_Obj_set( alpha, datatype, &value );
      PLA_Scal( alpha, X );
      PLA_Local_axpy( PRISM_one, temp, X );
      *n_1 += *n_half;
      *n_half = 0.;
   }

   PLA_Obj_free(&temp);
   PLA_Obj_free(&alpha);

#ifdef DB_GLOBAL_
     if (me==ROOT) printf(">> PRISM_map_half\n");
#endif

}
