#include "PLA.h"
#include "math.h"
#include "PRISM.h"

/* The following will go into an included .h file */
#define SKIP_NO
#define PRISM_PRT_
#define DEPS 0.1

int tnb;
double SVDEPS;

void prism_pla_dschr2_(double *,double *,double *,double *,double *); 

/****************************************************************/

void prism_pla_trisvd(PLA_Obj A, PLA_Obj Q)
{

  int 
    idummy, info, k, j, pnlsz, iwork, g_l, lld,
    cols, m, n, im, in;

  PLA_Obj 
    q1=NULL,        q2=NULL,   Qpnl=NULL, star=NULL,
    CO=NULL, SI=NULL, CO2=NULL,  SI2=NULL,
    Qcur = NULL,    Acur = NULL,    work =NULL;

  PLA_Obj 
    PLA_ONE=NULL,
    PLA_MONE=NULL,
    PLA_ZERO=NULL;
  
  MPI_Datatype
    datatype;

  MPI_Comm
    comm1d;
  
  PLA_Template
    template;
  
  void
    *buf_localA = NULL,
    *one_buf, *co, *si,
    *zero_buf;

  PLA_Obj 
    alpha = NULL;
    
  void
    *acur_buf, *alpha_buf;

  double 
    *buffer;

  char
    trans[1],
    notrans[1];

  /* *F changed to F (and below) by stp */
  double
    *D, *E, F,
    r_one=1.0, r_zero=0.0;

  int
    i_one=1, i_zero=0;

  char
    cmach='e';

  info=0;
  PLA_Matrix_global_all( Q, &idummy, &n, &im, &in, &template);

  if( idummy !=n ) 
    info = 1;
  
  PLA_Matrix_global_all( A, &m, &n, &im, &in, &template);

  if( m != n ) 
    info = 2;
  else if (idummy != n) 
    info = 3;

  if (info != 0) {
    if (me==0) printf ("\nPLA_trisvd.c at node ??: wrong argument (info=%d)\n",info);
    return;
  }
/*
  PLA_Base_comm(&comm1d);
  MPI_Cart_get(comm1d, idummy, np, period, coord);
*/

#ifdef SKIP
  SVDEPS = 2*sqrt((double)n)*dlamch_( &cmach );
#else
  SVDEPS = 0.0;
#endif

  PLA_Temp_nb(template, &tnb);

  /* create multiscalars PLA_ONE, PLA_ZERO) */
  PLA_Mscalar_create(MPI_DOUBLE, PLA_ALL_ROWS, PLA_ALL_COLS, 1, 1, 
		     template, &PLA_ONE);
  PLA_Obj_set_to_one(PLA_ONE);

  PLA_Mscalar_create(MPI_DOUBLE, PLA_ALL_ROWS, PLA_ALL_COLS, 1, 1, 
		     template, &PLA_MONE);
  PLA_Obj_set_to_minus_one(PLA_MONE);
 
  PLA_Mscalar_create(MPI_DOUBLE, PLA_ALL_ROWS, PLA_ALL_COLS, 1, 1, 
		     template, &PLA_ZERO);
  PLA_Obj_set_to_zero(PLA_ZERO);

  PLA_Mscalar_create(MPI_DOUBLE, PLA_ALL_ROWS, PLA_ALL_COLS, 2, n, 
      template, &Acur);
  PLA_Obj_set_to_zero(Acur);

  PLA_Mscalar_create(MPI_DOUBLE, PLA_ALL_ROWS, PLA_ALL_COLS, 2, 2, 
      template, &work);
  PLA_Obj_set_to_zero(work);

  PLA_Obj_split_4(work, 1, 1, &CO, &SI2, &SI, &CO2);

  PLA_Pmvector_create_conf_to(Q, PLA_PROJ_ONTO_COL, PLA_ALL_COLS, 2, &q1);
  PLA_Pmvector_create_conf_to(Q, PLA_PROJ_ONTO_COL, PLA_ALL_COLS, 2, &q2);
  PLA_Obj_set_to_zero(q1);  PLA_Obj_set_to_zero(q2);

  /* Collect diag and sub-diag entries of A */ 

/* This crashes...I'm not sure why. */
/*
  PLA_API_begin();
  PLA_Obj_API_open( A);

  for (k=0; k<n; k++) {    
    PLA_Obj_view(Acur, 2, 1, 0, k, &star);
    PLA_API_axpy_global_to_matrix((k==n-1)?1:2,1,&r_one,A,k,k,star->buffer,2); 
  }
  
  PLA_Obj_API_close( A);
  PLA_API_end();
*/

/* This is less efficient but does the same thing. */

  for (k=0; k<n-1; k++) {    
    PLA_Obj_view(A, 2, 1, k, k, &star); 
    PLA_Obj_view(Acur, 2, 1, 0, k, &alpha);
    PLA_Copy(star,alpha);
  }
  PLA_Obj_view(A, 1, 1, n-1, n-1, &star);
  PLA_Obj_view(Acur, 1, 1, 0, n-1, &alpha);
  PLA_Copy(star,alpha);

  /* printf("me %d is in col %d\n", me, template->mycol); */
  /* odd & even sweep */
  D= (double *) Acur->buffer;
  lld=Acur->local_lld;
  E=D+1;
  for (k=0; k<n-1; k+=2) { /* odd sweep */ 
    if (ABS(*E) >= SVDEPS) {
      prism_pla_dschr2_(D, D+lld, E, CO->buffer, SI->buffer);
      /*printf("D=%11.4e D+1=%11.4e CO=%11.4e SI=%11.4e\n\n",
	     *D, *(D+lld), *(double *)CO->buffer,*(double *)SI->buffer);*/
      PLA_Local_copy(CO, CO2);
      PLA_Local_copy(SI, SI2);
      PLA_dscal(&i_one, PLA_MONE->buffer, SI2->buffer, &i_one);
      if (k!=k-2) *(E+lld) *= *(double *)CO->buffer;
      if (k!=0) *(E-lld) *= *(double *)CO->buffer;

      PLA_Obj_view(Q, n, 2, 0, k, &Qcur);

      if (Qcur->owner_right_block == Qcur->owner_left_block) {
	if (Qcur->local_width !=0) {
	  PLA_Local_gemm(PLA_NO_TRANS, PLA_NO_TRANS, PLA_ONE, Qcur, work,
			 PLA_ZERO, q1);
	  PLA_Local_copy(q1, Qcur);
	}
      }
      else {
	PLA_Copy(Qcur, q1);
	if (Qcur->local_width !=0) {
	  PLA_Local_gemm(PLA_NO_TRANS, PLA_NO_TRANS, PLA_ONE, q1, work,
			 PLA_ZERO, q2);
	  if(template->mycol == Qcur->owner_left_block) { 
	    PLA_Obj_view(q2, n, 1, 0, 0, &star);
	    PLA_Local_copy(star, Qcur);
	  }
	  else {
	    PLA_Obj_view(q2, n, 1, 0, 1, &star);
	    PLA_Local_copy(star, Qcur);
	  }		 
	}
      }
      D+=2*lld;  E=D+1; 
    }
  } /* end of odd */ 
  /*printf("++++++++++\n"); */

  D= (double *) Acur->buffer;
  D = D+lld;
  E=D+1;
  for (k=1; k<n-1; k+=2) { /* even sweep */
    if (ABS(*E) >= SVDEPS) {
      prism_pla_dschr2_(D, D+lld, E, CO->buffer, SI->buffer);
      /*printf("D=%11.4e D+1=%11.4e CO=%11.4e SI=%11.4e\n\n",
	     *D, *(D+lld), *(double *)CO->buffer,*(double *)SI->buffer);*/
      PLA_Local_copy(CO, CO2);
      PLA_Local_copy(SI, SI2);
      PLA_dscal(&i_one, PLA_MONE->buffer, SI2->buffer, &i_one);
      if (k!=k-2) *(E+lld) *= *(double *)CO->buffer;
      *(E-lld) *= *(double *)CO->buffer;

      PLA_Obj_view(Q, n, 2, 0, k, &Qcur);

      if (Qcur->owner_right_block == Qcur->owner_left_block) {
	if (Qcur->local_width !=0) {
	  PLA_Local_gemm(PLA_NO_TRANS, PLA_NO_TRANS, PLA_ONE, Qcur, work,
			 PLA_ZERO, q1);
	  PLA_Local_copy(q1, Qcur);
	}
      }
      else {
	PLA_Copy(Qcur, q1);
	if (Qcur->local_width !=0) {
	  PLA_Local_gemm(PLA_NO_TRANS, PLA_NO_TRANS, PLA_ONE, q1, work,
			 PLA_ZERO, q2);
	  if(template->mycol == Qcur->owner_left_block) { 
	    PLA_Obj_view(q2, n, 1, 0, 0, &star);
	    PLA_Local_copy(star, Qcur);
	  }
	  else {
	    PLA_Obj_view(q2, n, 1, 0, 1, &star);
	    PLA_Local_copy(star, Qcur);
	  }		 
	}
      }
      D+=2*lld;  E=D+1; 
    }
  } /* end of even */
  /*printf("Q-even::\n");  PRISM_long_print(Q); */
  /* global permutation */
  D= (double *) Acur->buffer;
  j=n-1;
  E= D + (n-1)*lld;
  PLA_Obj_view_shift(q1, 0, 0, -1, 0);
  PLA_Obj_view_shift(q2, 0, 0, -1, 0);

  for (k=0; k<n; k++, D+=lld) {
    if (*D < DEPS ) {
      while (*E < DEPS && j > k)  {E -= lld; j--;} 

      if (j==k) break;

      if (*E < 1-DEPS) {
	printf("E-value E=%11.4e is not near 0 or 1\n", *E);
	break;
      }

      F=*D; *D=*E; *E=F;
      PLA_Obj_view(Q, n, 1, 0, k, &Qcur);
      PLA_Obj_view(Q, n, 1, 0, j, &Qpnl);

      if (Qcur->owner_right_block == Qpnl->owner_left_block) {
	if (Qcur->local_width >0) {
	  PLA_Local_copy(Qcur, q1);
	  PLA_Local_copy(Qpnl, Qcur);
	  PLA_Local_copy(q1, Qpnl);
	}	
      }  
      else {
	PLA_Copy(Qcur, q1);
	PLA_Copy(Qpnl, q2);
	if (Qcur->local_width >0) PLA_Local_copy(q2, Qcur);
	if (Qpnl->local_width >0) PLA_Local_copy(q1, Qpnl);
      }
    }
    else if (*D < 1-DEPS) {
      printf("E-value D=%11.4e is not near 0 or 1\n", *D);
      break;
    }
  }
  /* printf("Q-permute::\n");  PRISM_long_print(Q); */
  
  PLA_Obj_free(&Acur);   PLA_Obj_free(&work);    PLA_Obj_free(&Qcur);
  PLA_Obj_free(&q1); PLA_Obj_free(&q2); PLA_Obj_free(&Qpnl);
  PLA_Obj_free(&CO); PLA_Obj_free(&SI); PLA_Obj_free(&star); 
  PLA_Obj_free(&CO2); PLA_Obj_free(&SI2);   PLA_Obj_free(&alpha);
  PLA_Obj_free(&PLA_ONE); PLA_Obj_free(&PLA_MONE); PLA_Obj_free(&PLA_ZERO);

}



